/* Include file required by users of mus_lib.c.
   4 August 1998. JCH. For version 1 of library
   5 February 1999. JCH. Version 1.1.
   4 March 1999. PWP. Version 1.1b - tidy up
   28 July 1999. JCH. Version 1.2 add mus_read_compress_event. 
   31 July 1999. JCH. Version 1.3 add mus_clear_buffer
   12 Oct 1999. PWP. Version 1.3b - change nevents to type int
   4 August 2000. PWP. Version 1.4 add mus_add_histogram
 */

/* Function prototypes */

int mus_exit();
#if defined(__STDC__)
int mus_add_histogram(short identifier, short hilo, short stream, short *length, short **buffer);
int mus_clear_buffer(short identifier, int *nevents);
int mus_clear_histogram(short identifier, short stream);
int mus_read_clock_cntl(short identifier, short *clock);
int mus_read_compress_event(short identifier, short *length, short **buffer);
int mus_read_event(short identifier, short *length, short **buffer);
int mus_read_histogram(short identifier, short hilo, short stream, short *length, short **buffer);
int mus_read_readout_cntl(short identifier, short *mdaqen, short *mroen);
int mus_read_readout_modes(short identifier, short *raw_mode, short *sample_all);
int mus_read_status(short identifier, short *status);
int mus_read_stream_enable(short identifier, short stream, short *enable);
int mus_read_stream_paf(short identifier, short stream, short *paf);
int mus_read_stream_status(short identifier, short stream, short *status);
int mus_read_stream_trlim(short identifier, short stream, short *trlim);
int mus_read_testmode(short identifier, short *mode);
int mus_release_event(short identifier);
int mus_reset(short identifier);
int mus_set_clock_cntl(short identifier, short clock);
int mus_set_readout_modes(short identifier, short raw_mode, short sample_all);
int mus_set_readout_cntl(short identifier, short mdaqen, short mroen);
int mus_set_stream_delay(short identifier, short stream, short delay);
int mus_set_stream_enable(short identifier, short stream, short enable);
int mus_set_stream_paf(short identifier, short stream, short paf);
int mus_set_stream_trlim(short identifier, short stream, short trlim);
int mus_set_testfifo(short identifier, short fifo);
int mus_set_testmode(short identifier, short mode);
int mus_set_testtrig(short identifier);
int mus_test_buffer(short identifier, short *empty);
int mus_test_fifos(short identifier, short *empty);
int mus_vmemap(unsigned long address,short *identifier);
/* test functions */
int mus_loop_stren(short identifier, short offset);
int mus_test_event(short identifier, short *length, short **buffer, int *nevents, short *nerrors, short dump);
int mus_test_hmem(short identifier);
int mus_test_stren(short identifier);
void mus_dump_event(short identifier, unsigned short *data);
/*end of test functions */
#else
int mus_add_histogram();
int mus_clear_buffer();
int mus_clear_histogram();
int mus_read_clock_cntl();
int mus_read_compress_event();
int mus_read_event();
int mus_test_event();
int mus_read_histogram();
int mus_read_readout_cntl();
int mus_read_readout_modes();
int mus_read_status();
int mus_read_stream_enable();
int mus_read_stream_paf();
int mus_read_stream_status();
int mus_read_stream_trlim();
int mus_read_testmode();
int mus_release_event();
int mus_reset();
int mus_set_clock_cntl();
int mus_set_readout_modes();
int mus_set_readout_cntl();
int mus_set_stream_delay();
int mus_set_stream_enable();
int mus_set_stream_paf();
int mus_set_stream_trlim();
int mus_set_testfifo();
int mus_set_testmode();
int mus_set_testtrig();
int mus_test_buffer();
int mus_test_fifos();
int mus_vmemap();
/* test functions */
int mus_loop_stren();
int mus_test_event();
int mus_test_hmem();
int mus_test_stren();
void mus_dump_event();
/*end of test functions */
#endif

/* defines */

#define MAX_STREAM 11
#define MAX_DELAY  23

/*end of mus_lib.h */
