/* Version 1.? PWP 12 Oct 1999. Put variable declarations of 
 *                              arguments into parentheses.
 * Version Carlos May 2002 - tidy up menu option
 */

#include <stdio.h>
#include "mus_lib.h"
#include "mus_user.h"

#include "../stlib/sct_hardware.h"

#define EVBUFSIZE 150000
#define EVMAX 1000

short enable[12] = {0,0,0,0,1,1,0,0,0,0,0,0};
short delay[12] = {20,15,15,15,15,6,7,8,9,10,11,12};
short paf = 3;   /* PAF = Programmable Almost Full Flag; */ 
		    /* 3=>8k bytes before full*/
short trlim = 3;
short raw_mode = 0;
short sample_all = 1;
short mdaqen = 1;
short mrdoen = 1;
short normal_mode = 0;
short test_mode = 0;

unsigned short evdata[EVBUFSIZE];
short *evpointer;
short evlength;
int evmax;

short mword_count;
short merror_count;
short mevent_count_ls;
short mevent_count_ms;
unsigned int mevent_count;

short hdata[0x800];
short *hpointer;
short hlength;

short id;

int mus_test_menu();

main()
{
  unsigned long i;
  int j;

  short st;

  i = MUS_ADDRESS;
  j = mus_vmemap(i,&id);
  printf("vme_map status %d  returns id %x\n",j,id);

  j = mus_read_status(id,&st);
  j = mus_print_status(st);

  mdaqen = 0;
  mrdoen = 0;
  j = mus_set_readout_cntl(id,mdaqen,mrdoen);

  mus_test_menu();

/*
  j = mus_init(id);
  printf("init status %d\n",j);

  j = mus_read_status(id,&st);
  j = mus_print_status( st);

  j = mus_do_loop_events(id, -1);

  j = mus_do_loop_histo(id, 1000);

  j = mus_do_delay_scan(id,0);

  mdaqen = 0;
  mrdoen = 0;
  j = mus_set_readout_cntl(id,mdaqen,mrdoen);

  j = mus_clear_histogram(id,0);

  mdaqen = 1;
  mrdoen = 1;
  j = mus_set_readout_cntl(id,mdaqen,mrdoen);

  j = mus_do_loop_events(id, 1000);

  mdaqen = 0;
  mrdoen = 0;
  j = mus_set_readout_cntl(id,mdaqen,mrdoen);

  for (i=0; i<12; i++) {
    if (enable[i] == 1) {
      hpointer = hdata;
      hlength = 0;
      j = mus_read_histogram(id, i, &hlength, &hpointer); 
      printf("mus_test: reading hists for stream %d  length %d\n",i,hlength);
      for (j=0; j<768; j++) {
         if (hdata[j] != 0) 
        printf("strip: %3d  nhits: %5d\n", j, hdata[j]);
      }
    }
  }

  j = mus_read_status(id,&st);
  j = mus_print_status(st);

  j = mus_test_hmem(id); ### shows correct reading from hmem if mrdoen==0 
  j = mus_loop_stren(id, 0); ### shows read error if scoped 
*/

  printf("mus_test: ending\n");

  return 0;
}



int mus_test_menu() {
  short j;
  short st;
  char cm[128];
  char c;
  int v = 0;
  int run = 1;

  while(run) {
    printf("MUS:  (d)defaults  (x)exit  s(status)  \n");
    printf("      (r)MRDOEN (q)MDAQEN (a)Sample_all  (w)Raw_mode \n");
    printf("      (e)event  (l)loop_events  (h)histograms \n");
    printf("      (z)delay scan \n");
    scanf("%1s", cm);
    c = cm[0];
    if (c == 'x') run = 0;
    else if (c == 'd') mus_init(id);
    else if (c == 's') {
      j = mus_read_status(id,&st);
      j = mus_print_status( st);
    }
    else if (c == 'r') {
      printf("MRDOEN should be %d; ", mrdoen);
      if (mrdoen == 0) mrdoen = 1; 
      else mrdoen = 0;
      printf("  setting to %d\n", mrdoen);
      j = mus_set_readout_cntl(id,mdaqen,mrdoen);
    }
    else if (c == 'q') {
      printf("MDAQEN should be %d; ", mdaqen);
      if (mdaqen == 0) mdaqen = 1; 
      else mdaqen = 0;
      printf("  setting to %d\n", mdaqen);
      j = mus_set_readout_cntl(id,mdaqen,mrdoen);
    }
    else if ( c == 'e' ) {
      printf("Not yet implemented\n");
    }
    else if ( c == 'l' ) {
      printf("Not yet implemented\n");
    }
    else if ( c == 'h' ) {
      mus_do_loop_histo(id, 1000);
    }
    else if ( c == 'z' ) {
      mrdoen = 1;
      mus_do_delay_scan(id,0);
    }
    else {
      printf("MUS: ERROR: unknown command %c\n", c);
    }
  }
  return(0);
}



/*.......................................................*/
/* mus_init - initialise a MuSTARD*/
int mus_init(short id)
{
int i,j,code;
short k,l;

  code = 0;
  j = mus_reset(id);		/*reset the module*/
  if(j != 0) code = j;

  j = mus_set_clock_cntl(id, 0);

  for(i=0;i<=MAX_STREAM;i++) {
      j = mus_set_stream_enable(id,i,enable[i]);
      if (i==0) j = mus_set_stream_enable(id,i,enable[i]); 
      if(j != 0) code = j;
      j = mus_read_stream_enable(id,i,&k); 
      if(j != 0) code = j;
      j = mus_read_stream_enable(id,i,&k); 
      j = mus_read_stream_enable(id,i,&k); 
      j = mus_read_stream_enable(id,i,&k); /* ask Maurice */
      if(k != enable[i]) printf(
        "mus_init: stream enable wrong,id=%d, stream=%d, set=%d, read=%d\n",
        id,i,enable[i],k); 

      /* printf("mus_init: doing stream enable %x %x %x\n", i, enable[i], k);
      j = mus_test_stren(id); */ 
  }

  for(i=0;i<=MAX_STREAM;i+=4) {
      j = mus_set_stream_paf(id,i,paf);
      if(j != 0) code = j;
      j = mus_read_stream_paf(id,i,&k);
      if(j != 0) code = j;

      if(k != paf) printf(
        "mus_init: stream PAF wrong,id=%d, stream=%d, set=%d, read=%d\n",
        id,i,paf,k);
      j = mus_set_stream_trlim(id,i,trlim);
      if(j != 0) code = j;
      j = mus_read_stream_trlim(id,i,&k);
      if(j != 0) code = j;
      if(k != trlim) printf(
        "mus_init: stream TRLIM wrong,id=%d, stream=%d, set=%d, read=%d\n",
        id,i,trlim,k);
  }

  for(i=0;i<=MAX_STREAM;i++) {
      j = mus_set_stream_delay(id,i,delay[i]);
      if(j != 0) code = j;
  }

  j = mus_set_testmode(id,normal_mode);
  j = mus_read_testmode(id,&k);
  if(k != normal_mode) printf(
     "mus_init: testmode wrong,id=%d, set=%d, read=%d\n",
     id,normal_mode,k);
  if(j != 0) code = j;

  j = mus_set_readout_modes(id,raw_mode,sample_all);
  if(j != 0) code = j;
  j = mus_read_readout_modes(id,&k,&l);
  if(j != 0) code = j;
  if(k != raw_mode || l != sample_all) printf(
     "mus_init: readout mode register wrong,id=%d, set=%d %d, read=%d %d\n",
     id,raw_mode, sample_all,k,l);

  j = mus_set_readout_cntl(id,mdaqen,mrdoen);
  if(j != 0) code = j;
  j = mus_read_readout_cntl(id,&k,&l);
  if(j != 0) code = j;
  if(k != mdaqen || l != mrdoen) printf(
     "mus_init: readout cntl register wrong,id=%d, set=%d %d, read=%d %d\n",
     id,mdaqen,mrdoen,k,l);

  printf("mus_init: setting readout_cntl %x mdaqen %x %x  mrdoen %x %x\n", 
    j, mdaqen, k, mrdoen, l);

  j = mus_read_status(id,&k);
  if(j != 0) code = j;
  printf("mus_init: status register contains %x\n",k);

  return code;
}

/*....................................................*/
int mus_print_status(short st)
{
 short sadd; 
 short rdpage,wrpage;

 printf("mus_stat: %3x ", st);
 sadd = st & 0x00f;  printf(" SADD: %1x ", sadd);
 if (st & 0x010) printf(" MDAQEN ");
 if (st & 0x020) printf(" MRDOEN ");
 if (st & 0x080) printf(" SSTAT ");
 if (st & 0x100) printf(" SDAV ");
 if (st & 0x200) printf(" SREN ");
 if ((st & 0x400) == 0) printf(" TRH ");
 if (st & 0x800) printf(" BCO-OK ");
 
 rdpage = ((st & 0x040) >> 6);
 rdpage = rdpage | ((st & 0x1000) >> 11); printf(" RDPAGE: %x ", rdpage);
 wrpage = ((st >> 13) & 3);
 printf("WRPAGE: %d",wrpage);

 printf("\n");

 return 0;
}

/*.................................................*/
int mus_do_delay_scan(short id, int stream)
{
  int xdelay;
  int i = 0;

  if ((stream < 0) || (stream > 11)) 
    printf("ERROR: Stream illegal %d\n", stream);

  for (xdelay = 0; xdelay<1000; xdelay++) {
    delay[stream] = xdelay%25;
    printf("mus_do_delay_scan: xdelay: %d delay: %d\n", 
      xdelay, delay[stream]);
    mus_init(id);
    mus_do_loop_events(id, 1000);    

    /* Show sumary of last event */
    mword_count = evdata[0];
    merror_count = evdata[1];
    mevent_count = (evdata[3] << 16) + (evdata[2]);
  
    printf("mus_event: %d  evlength: %d  wc: %d evcnt: %d delay: %d errcnt: %d\n", 
      i, evlength, mword_count, mevent_count, delay[stream], merror_count);
  }
  return(0);
}

/*.........................................................*/
int mus_do_loop_events(short id, int nevents)
{
  int i,j,nmax;
  short st;
  long nevt = 0;
  int nbad = 0;  

  nmax = 100000;
  if (nevents > 0) nmax = nevents;

  for (i=0; i<nmax; i++) {   
    evpointer = evdata;
    evlength = 0;
    j = mus_read_event(id, &evlength, &evpointer);

    nevt++;
    if (j != 0) {
      nbad++;
      printf("mus_do_loop_events: read ERROR type: %d after %ld events,  %d bad\n",j,nevt,nbad);
      mus_read_status(id,&st);
      mus_print_status(st);
    }    

    printf("mus_do_loop_events: event number: %d  nevt: %ld  nbad: %d\n",
       i,nevt,nbad);
    mword_count = evdata[0];
    merror_count = evdata[1];
    mevent_count = (evdata[3] << 16) + (evdata[2]);
    printf("mus_event: %d  evlength: %d  wc: %d  errcnt: %d evcnt: %d\n", 
        i, evlength, mword_count, merror_count, mevent_count);
 /*   
    if ((i%100)==0) {
      printf("mus_do_loop_events: event number: %d  nevt: %ld  nbad: %d\n",
       i,nevt,nbad);
      mus_read_status(id,&st);
      mus_print_status(st);

      mword_count = evdata[0];
      merror_count = evdata[1];
      mevent_count = (evdata[3] << 16) + (evdata[2]);
      printf("mus_event: %d  evlength: %d  wc: %d  errcnt: %d evcnt: %d\n", 
        i, evlength, mword_count, merror_count, mevent_count);
      if (nevents < 0) i = 0;

      if (evdata[0] > 0) {
        evmax = evdata[0];\
        if (evdata[0] > EVMAX) evmax = EVMAX;
        for (j=0; j<evmax; j++) {
           pr16bits(evdata[j]);
          printf("%4x ",evdata[j]);
          evdata[j] = 0;
          if ((j%10)==9) printf("\n");
        }
        printf("\n");
      }
    }  */
  }
  return(0);
}

int pr16bits(unsigned short v)
{
  int i;
  printf(" %x ",v);
  for (i=15;i>=0;i--) { 
    if ((v>>i)&0x0001) printf("1");
    else printf("0");
  }
  return 0;
}

/*.........................................................*/
int mus_do_loop_histo(short id, int nevents)
{
  int i,j,nmax;
  short st;
  long nevt = 0;
  int nbad = 0;  

  nmax = 100000;
  if (nevents > 0) nmax = nevents;

  
  j = mus_set_readout_cntl(id,0,0);

  j = mus_clear_histogram(id,0);  /* ### need to clear all active streams */  


  for (i=0; i<nmax; i++) {   
    evpointer = evdata;
    evlength = 0;
    j = mus_read_event(id, &evlength, &evpointer);

    nevt++;
    if (j != 0) {
      nbad++;
      printf("mus_do_loop_events: read ERROR type: %d after %ld events,  %d bad\n",j,nevt,nbad);
      mus_read_status(id,&st);
      mus_print_status(st);
    }    
    
    if ((i%100)==99) {
      printf("mus_do_loop_events: event number: %d  nevt: %ld  nbad: %d\n",
       i,nevt,nbad);
      mus_read_status(id,&st);
      mus_print_status(st);

      mword_count = evdata[0];
      merror_count = evdata[1];
      mevent_count = (evdata[3] << 16) + (evdata[2]);
      printf("mus_event: %d  evlength: %d  wc: %d  errcnt: %d evcnt: %d\n", 
        i, evlength, mword_count, merror_count, mevent_count);
      if (nevents < 0) i = 0;

      if (evdata[0] > 0) {
        evmax = evdata[0];
        if (evdata[0] > EVMAX) evmax = EVMAX;
        for (j=0; j<evmax; j++) {
          /* pr16bits(evdata[j]); */ printf("%4x ",evdata[j]);
          evdata[j] = 0;
          if ((j%10)==9) printf("\n");
        }
        printf("\n");
      }
    }
  }
  return(0);
}


