#ifdef QB_linux
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "InitVME.h"

static int qb_fd=-1;
void InitVME() {
    if (qb_fd >0) {
      printf("Initqb: /dev/qb0 already initialised \n");
      return;
    }

    if ((qb_fd = open("/dev/qb0",O_RDWR) ) < 0) {
      printf("Initqb: can't open /dev/qb0 \n");
      exit(-1);
    }
    
    /* reset VME */
    ioctl(qb_fd,QB_VME_RESET);
    sleep(1);      
}

void ResetVME() {
   if ( qb_fd<0 ) InitVME();
   else {
      ioctl(qb_fd,QB_VME_RESET);
      sleep(1);
   }      
}

void Initqb(unsigned long *addr, int size, unsigned short AddMod)
{
  if (qb_fd<0) 
     InitVME();

  /* select VME space */
  ioctl(qb_fd, QB_VME_AMOD, AddMod);

  /* mmap vme memory */
  *addr = (unsigned long) mmap(
       NULL,
       (size_t) size,
       PROT_READ|PROT_WRITE,
       MAP_SHARED,
       qb_fd,
       *addr);

  if (*(long*)addr == -1) {
    printf("Initqb: vme error \n");
    exit(-1);
  }
  
  /* debug */
//  ioctl(qb_fd,QB_LST_AREA);
  
  return;
  
}


void InitInterrupts(int irq, int vct) {
   struct QBINTR qbintr;
   if ( qb_fd<0 ) {
      printf("bit3 driver not initialized\n");
      return;
   }
   if (fcntl(qb_fd, F_SETOWN, getpid()) < 0) {
      printf("InitInterrups: F_SETOWN -> %s\n",strerror(errno));
      exit(1);
   }
   /* struct, vme_irq, vme_vector */
   printf("InitInterrupts : %d.%d [%d]",irq,vct,getpid());
   QBFINTR(&qbintr,irq,vct);
   if (ioctl(qb_fd, QB_SET_INTR, &qbintr) < 0) {
      printf("InitInterrups: QB_SET_INTR-> %s\n",strerror(errno));
      exit(1);
   }
}

#endif
