/*  slog_lib.h    slog_lib.c public header file
 *    Version 0.1   981026 GFM
 *    Version 0.2   990803 PWP
 */

#ifdef __STDC__

int slog_show_status(short id);
void slog_test_regs(short id);

int slog_init(short id);
int slog_reset(short id);
int slog_clear(short id);

int slog_load(short id, unsigned short *cb, unsigned int size);
int slog_fload(short id, char *cb_filespec);
int slog_dump(short id);
int slog_show_ram(short id, unsigned short start, unsigned short stop);
int slog_dump_ram(short id, unsigned short start, unsigned short stop);

int slog_start(short id);
int slog_stop(short id);

int slog_set_runstate(short id, unsigned short runstate);
int slog_get_runstate(short id, unsigned short *runstate);

int slog_set_startaddr(short id, unsigned short startaddr);
int slog_get_startaddr(short id, unsigned short *startaddr);

int slog_set_cycles(short id, unsigned short cycles);
int slog_get_cycles(short id, unsigned short *cycles);

int slog_enable_busy(short id, unsigned short busy);
int slog_disable_busy(short id, unsigned short busy);
int slog_set_busy(short id, unsigned short bmap);
int slog_get_busy(short id, unsigned short *bmap);

int slog_enable_clock(short id);
int slog_disable_clock(short id);
int slog_set_clock(short id, unsigned short bmap);
int slog_get_clock(short id, unsigned short *clock);

int slog_enable_external(short id);
int slog_disable_external(short id);
int slog_set_external(short id, unsigned short bmap);
int slog_get_external(short id, unsigned short *external);

int slog_enable_internal(short id);
int slog_disable_internal(short id);
int slog_set_internal(short id, unsigned short bmap);
int slog_get_internal(short id, unsigned short *internal);

int slog_set_gmra(short id, unsigned short ch);
int slog_set_gmrb(short id, unsigned short ch);

int slog_exit();
int slog_vmemap(unsigned long address, short *identifier);

int slog_all_abc( short id, 
  float vthr, float vcal, unsigned short delay, float febias, float feshaper);

int slog_test_revision(short id);
int slog_set_clk_cntl(short id, unsigned short bmap);
int slog_get_clk_cntl(short id, unsigned short *clk_cntl);
int slog_set_clock_duty(short id, unsigned short duty);
int slog_get_clock_duty(short id, unsigned short *duty);
int slog_set_clock_phase(short id, unsigned short phase);
int slog_get_clock_phase(short id, unsigned short *phase);

int slog_test_mem(short id);

#else

int slog_show_status();
void slog_test_regs();

int slog_init();
int slog_reset();
int slog_clear();

int slog_load();
int slog_fload();
int slog_dump();
int slog_show_ram();
int slog_dump_ram();

int slog_start();
int slog_stop();

int slog_set_runstate();
int slog_get_runstate();

int slog_set_startaddr();
int slog_get_startaddr();

int slog_set_cycles();
int slog_get_cycles();

int slog_enable_busy();
int slog_disable_busy();
int slog_set_busy();
int slog_get_busy();

int slog_enable_clock();
int slog_disable_clock();
int slog_set_clock();
int slog_get_clock();

int slog_enable_external();
int slog_disable_external();
int slog_set_external();
int slog_get_external();

int slog_enable_internal();
int slog_disable_internal();
int slog_set_internal();
int slog_get_internal();

int slog_set_gmra();
int slog_set_gmrb();

int slog_exit();
int slog_vmemap();

int slog_all_abc();

int slog_test_revision();
int slog_set_clk_cntl();
int slog_get_clk_cntl();
int slog_set_clock_duty();
int slog_get_clock_duty();
int slog_set_clock_phase();
int slog_get_clock_phase();

int slog_test_mem();

#endif

