/* 
    slog_test.c    --- Simple text mode test menu for SLOG

    GFM Nov98
*/


#include <stdio.h>
#include "slog_lib.h"

#include "../stlib/sct_hardware.h"

int slog_menu(short id);
void slog_clock(short id, short ch);
void slog_internal(short id);
void slog_external(short id);

main()
{
   short id;
   unsigned long address = SLOG_ADDRESS;

   printf("slog: attempting VME map for address %x\n", address); 

   slog_vmemap(address,&id);
   printf("slog: vmemap returns id %x\n", id);

/*   slog_init(id); */
/*   slog_fload(id,"test.cb");
     slog_show_ram(id, 1800, 2000);  */
   slog_show_status(id);
   slog_menu(id);
   slog_exit(id);

   return 0;
}


int slog_menu(short id) {
  char cm[128];
  char c;
  int v = 0;
  int run = 1;
  int nburst = 0;
  float vthr,vcal,febias,feshaper;
  unsigned short delay;
  
  while(run) {
    printf("SLOG: (s)tart sto(p) c(ycles) b(urst) test_(m)emory e(x)it\n");
    printf("      i(int on) j(int off) e(ext on) f(ext off) k(clk on) l(clk off) \n");
    printf("      show_(r)am \n");
    scanf("%s", cm);
    c = cm[0];
    if (c == 'x') run = 0;
    else if (c == 'z') slog_show_status(id);
    else if (c == 's') { 
      printf("SLOG: sending\n"); 
      slog_start(id); 
      slog_show_status(id);
    } 
    else if (c == 'p') slog_stop(id);
    else if (c == 'i') slog_enable_internal(id);
    else if (c == 'j') slog_disable_internal(id);
    else if (c == 'e') slog_enable_external(id);
    else if (c == 'f') slog_disable_external(id);
    else if (c == 'k') slog_enable_clock(id);
    else if (c == 'l') slog_disable_clock(id);
    else if (c == 'm') printf("Memory test: %d errors\n",slog_test_mem(id));
    else if (c == 'd') slog_set_clock_duty(id, 4);
    else if (c == '0') slog_set_clock(id, 0x1555);
    else if (c == '1') slog_set_clock(id, 0x2aaa);
    else if (c == '2') slog_clock(id, 2);
    else if (c == '3') slog_internal(id);
    else if (c == '4') slog_external(id);
    else if (c == '5') slog_test_regs(id);
    else if (c == 'r') slog_show_ram(id, 0x0000,0x1000);
    else if (c == 'b') {
      printf("SLOG: reloading cycles to %d\n", nburst);
      slog_set_cycles(id,nburst);
      slog_start(id); 
      slog_show_status(id);
    } else if (c == 'c') { 
      printf("SLOG: how many cycles ?");
      scanf("%d", &nburst);
      if (nburst<1) {
        printf("SLOG: ERROR: nburst<1\n");
        nburst = 1;
      }
      nburst--;
      slog_set_cycles(id,nburst);
      slog_show_status(id);
    } else if (c == 'u') {
      printf("SLOG: vthr vcal delay febias feshaper\n");
      scanf("%f %f %d %f %f", &vthr, &vcal, &delay, &febias, &feshaper);
      slog_all_abc(id,vthr,vcal,delay,febias,feshaper);
    } else {
      printf("SLOG: ERROR: unknown command %c\n", c);
    }
  }

  return 0;
}


void slog_clock(short id, short ch){
  short get;
  
  slog_get_clock(id, &get);
  printf("slog_clock: id %d   map %x  \n", id, get);
  slog_get_internal(id, &get);
  printf("slog_clock: id %d   map %x  \n", id, get);

  slog_get_clock(id, &get);
  printf("slog_clock: id %d   map %x  \n", id, get);
  slog_get_internal(id, &get);
  printf("slog_clock: id %d   map %x  \n", id, get);
  slog_get_clock(id, &get);
  printf("slog_clock: id %d   map %x  \n", id, get);
  slog_get_internal(id, &get);
  printf("slog_clock: id %d   map %x  \n", id, get);


}

void slog_internal(short id){
  short get;

  slog_get_internal(id, &get);
  printf("slog_internal: id %d  map %x\n", id,  get);
}

void slog_external(short id){
  short get;
  
  slog_get_external(id, &get);

  printf("slog_external: id %d   map %x\n", id, get);
}
