void DCSvsT(Int_t run, Int_t firstscan, Int_t lastscan){
#define MAX_MODULES 18
#define MAX_SCANS  150

  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();
  Int_t i, j, scan, tsec=0, tfirst, nmod;
  Float_t max_n=1800., min_n=1000., data;
  Color_t col;
  Char_t line[1024],h_title[64],f_name[128];
  Double_t idet[MAX_MODULES][MAX_SCANS], idet1d[MAX_SCANS], tpoints[MAX_SCANS];
  Double_t icc[MAX_MODULES][MAX_SCANS], icc1d[MAX_SCANS];
  Double_t idd[MAX_MODULES][MAX_SCANS], idd1d[MAX_SCANS];
  Double_t t1[MAX_MODULES][MAX_SCANS], t11d[MAX_SCANS], tpoints2[MAX_SCANS];
  Double_t t2[MAX_MODULES][MAX_SCANS], t21d[MAX_SCANS];
  char mname[MAX_MODULES][32],a[10],b[10],c[10],d[10],timestr[10];
  Int_t tsec, nread, tstart,tend, npts;
  Char_t texta[1024];
  char mname2[MAX_MODULES][32], drive[32];

  sprintf(drive,"D:");
  //sprintf(drive,"\\\\Pcephl01");

  gROOT->ProcessLine(".L strtosec.cpp");

  if(lastscan-firstscan>=MAX_SCANS){
    printf("ERROR: too many scans, only up to %d is possible\n",MAX_SCANS);
    return;
  }

  // open canvas
  TCanvas* c6= new TCanvas ("c6","DCS2",1100,750);

  for(scan=0;scan<lastscan-firstscan+1;scan++){
    // open root file
    sprintf(f_name,"%s\\sctvar\\data\\strun%d_%d.root",drive,run,scan+firstscan);
    printf("opening file %s\n",f_name);
    TFile *strun = new TFile(f_name);
    TObjString* time  = (TObjString*)strun->Get("Time");
    TObjString* place = (TObjString*)strun->Get("Place");
    sscanf(time->GetName(), "%s %s %s %s %s",a,b,c,timestr,d);
    tsec = strtosec(timestr);
    if(scan==0) tfirst=tsec;
    tpoints[scan] = ((Double_t)(tsec-tfirst))/3600.;
    nmod=0;
    for (i=0; i<MAX_MODULES; i++){
      sprintf(h_title,"ModuleName;%d",i+1);
      TObjString* name = (TObjString*)strun->Get(h_title);
      if(name){
	if(strcmp(name->GetName(),"missing")){
	  sprintf(mname[nmod],"%s",name->GetName());
	  nmod++;
	  sprintf(h_title,"Idet;%d",i+1);
	  TGraph *histo = (TGraph*) strun->Get(h_title)->Clone();
	  fc= new TF1("fc","pol0",0.,500.);
	  histo->Fit("fc","0Q");
	  idet[i][scan] = fc->GetParameter(0);
	  sprintf(h_title,"Icc;%d",i+1);
	  TGraph *histo = (TGraph*) strun->Get(h_title)->Clone();
	  fc= new TF1("fc","pol0",0.,500.);
	  histo->Fit("fc","0Q");
	  icc[i][scan] = fc->GetParameter(0);
	  sprintf(h_title,"Idd;%d",i+1);
	  TGraph *histo = (TGraph*) strun->Get(h_title)->Clone();
	  fc= new TF1("fc","pol0",0.,500.);
	  histo->Fit("fc","0Q");
	  idd[i][scan] = fc->GetParameter(0);
	}
      }
    }
    strun->Close();
  }

  // DCS data

  sprintf(f_name,"%s\\sctvar\\data\\strun%d_%d.root",drive,run,firstscan);
  TFile *strun = new TFile(f_name);
  TObjString* time  = (TObjString*)strun->Get("Time");
  TObjString* place = (TObjString*)strun->Get("Place");
  sscanf(time->GetName(), "%s %s %s %s %s",a,b,c,timestr,d);
  tstart = strtosec(timestr);
  strun->Close();  
  sprintf(f_name,"%s\\sctvar\\data\\strun%d_%d.root",drive,run,lastscan);
  TFile *strun = new TFile(f_name);
  TObjString* time  = (TObjString*)strun->Get("Time");
  TObjString* place = (TObjString*)strun->Get("Place");
  sscanf(time->GetName(), "%s %s %s %s %s",a,b,c,timestr,d);
  tend = strtosec(timestr);
  strun->Close();  

  sprintf(f_name,"%s\\sctvar\\data\\dcs_%d.txt",drive,run);
  FILE* dcs = fopen(f_name,"r");
  nread = fscanf(dcs,"%s",texta);
  nmod=0;
  while(nread==1){
    for(i=0;i<4;i++){
      nread = fscanf(dcs,"%s",texta);
      if(i==0){
	for(j=0;j<100;j++)
	  if(texta[j]==':'||texta[j]=='\0') break;
	if(texta[j]==':') goto endmod;
	strcpy(mname2[nmod],texta);
	nmod++;
      }
    }
  }
 endmod:
  printf("found %d modules\n",nmod);
  for(i=0;i<2*nmod;i++){
    nread = fscanf(dcs,"%f",&data);
  }
  npts = -1;
  while(nread==1){
    nread = fscanf(dcs,"%s",timestr);
    for(j=0;j<9;j++)
      if(timestr[j]=='\0') break;
    if(j==8) break;
    timestr[j]   = ':';
    timestr[j+1] = '0';
    timestr[j+2] = '0';
    timestr[j+3] = '\0';
    tsec = strtosec(timestr);
    if(tsec>tstart&&tsec<=tend){
      npts++;
      tpoints2[npts] = ((Double_t) (tsec-tstart))/3600.;
    }
    else if(tsec>tend)
      break;
    for(i=0;i<2*nmod;i++){
      nread = fscanf(dcs,"%f",&data);
      if(tsec>tstart&&tsec<tend){
	if(i%2)
	  t1[i/2][npts] = data;
	else
	  t2[i/2][npts] = data;
      }
    }
  }
  printf("read %d DCS data points\n",npts);

  // plot results

  sprintf(f_name,"D:\\sctvar\\ps\\DCSvsT_%d.ps",date);
  ps = new TPostScript(f_name,112);
  for(i=0;i<nmod;i++){
    ps->NewPage();
    c6->cd();
    c6->Clear();
    pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
    pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
    pad_text->Draw();
    pad_plot->Draw();
    pad_plot->Divide(2,2,0,0);
    c6->Update();
    pad_text->cd();
    TPaveText *txt = new TPaveText(0.0,0.0,1.0,1.0);
    txt->SetFillColor(10);
    txt->SetTextAlign(13);
    txt->SetTextSize(0.3);
    txt->SetTextColor(4);
    sprintf(line,"ATLAS SCT: DCS Readings");
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    txt->AddText(line);
    sprintf(line,"Run %d   Scans %d-%d Module %s", run,firstscan, lastscan,mname[i]);
    txt->AddText(line);
    txt->Draw();
    c6->Update();
    for(j=0;j<scan;j++){
      idet1d[j] = idet[i][j];
      icc1d[j]  = icc[i][j];
      idd1d[j]  = idd[i][j];
    }
    for(j=0;j<npts;j++){
      t11d[j] = t1[i][j];
      t21d[j] = t2[i][j];
    }
    TGraph *grdt=new TGraph(scan,tpoints,idet1d);
    TGraph *grcc=new TGraph(scan,tpoints,icc1d);
    TGraph *grdd=new TGraph(scan,tpoints,idd1d);
    TGraph *grt1=new TGraph(npts,tpoints2,t11d);
    TGraph *grt2=new TGraph(npts,tpoints2,t21d);
    grdt->SetMarkerStyle(20);
    grdt->SetMarkerSize(1);
    grdt->SetMarkerColor((Color_t) 1);
    grdt->SetTitle("Idet vs Time");
    grcc->SetMarkerStyle(20);
    grcc->SetMarkerSize(1);
    grcc->SetMarkerColor((Color_t) 2);
    grcc->SetTitle("Icc vs Time");
    grdd->SetMarkerStyle(20);
    grdd->SetMarkerSize(1);
    grdd->SetMarkerColor((Color_t) 3);
    grdd->SetTitle("Idd vs Time");
    grt1->SetMarkerStyle(20);
    grt1->SetMarkerSize(1);
    grt1->SetMarkerColor((Color_t) 4);
    grt1->SetTitle("T vs Time");
    grt1->SetMinimum(22.);
    grt1->SetMaximum(32.);
    grt2->SetMarkerStyle(24);
    grt2->SetMarkerSize(1);
    grt2->SetMarkerColor((Color_t) 7);
    grt2->SetTitle("T vs Time");
    pad_plot->cd(1);
    grdt->Draw("AP");
    grdt->GetXaxis()->SetTitle("Time(h)");
    grdt->GetYaxis()->SetTitle("Idet(uA)");
    grdt->Draw("AP");
    pad_plot->cd(2);
    grcc->Draw("AP");
    grcc->GetXaxis()->SetTitle("Time(h)");
    grcc->GetYaxis()->SetTitle("Icc(mA)");
    grcc->Draw("AP");
    pad_plot->cd(3);
    grdd->Draw("AP");
    grdd->GetXaxis()->SetTitle("Time(h)");
    grdd->GetYaxis()->SetTitle("Idd(mA)");
    grdd->Draw("AP");
    pad_plot->cd(4);
    grt1->Draw("AP");
    grt1->GetXaxis()->SetTitle("Time(h)");
    grt1->GetYaxis()->SetTitle("T?1/2!(C)");
    grt1->Draw("AP");
    grt2->Draw("P");
    c6->Update();
  }
  ps->Close();

  return;
}
