void Icc_Idd(Int_t run, Int_t scan){
#define MAX_MODULES 18

  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();
  Int_t moi[3]={0,1,2}, i;
  Float_t max_n=1800., min_n=1000.;
  Color_t col;
  Char_t line[1024],mname[64],h_title[64],f_name[128];

  // open canvas
  TCanvas* c6= new TCanvas ("c6","I",1100,750);

  // write data to file and plot

  sprintf(f_name,"D:\\sctvar\\ps\\CurrPlot_%d.ps",date);
  ps = new TPostScript(f_name,112);

  ps->NewPage();
  c6->cd();
  c6->Clear();
  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
  pad_text->Draw();
  pad_plot->Draw();
  pad_plot->Divide(3,2,0,0);
  c6->Update();


  // open root file
  sprintf(f_name,"D:\\sctvar\\data\\strun%d_%d.root",run,scan);
  printf("opening file %s\n",f_name);
  TFile *strun = new TFile(f_name);
  for (i=0; i<3; i++){
    if(i==0){
      TObjString* time  = (TObjString*)strun->Get("Time");
      TObjString* place = (TObjString*)strun->Get("Place");
      pad_text->cd();
      TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
      t1->SetFillColor(10);
      t1->SetTextAlign(13);
      t1->SetTextSize(0.3);
      t1->SetTextColor(4);
      sprintf(line,"ATLAS SCT: Icc, Idd from S-curve scan at 2fC");
      if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
      if(place) sprintf(line,"%s  -  %s",line,place->GetName());
      t1->AddText(line);
      sprintf(line,"Run %d   Scan %d", run,scan);
      t1->AddText(line);
      t1->Draw();
      c6->Update();
    }
    sprintf(h_title,"ModuleName;%d",moi[i]+1);
    TObjString* name = (TObjString*)strun->Get(h_title);
    if(name){
      if(strcmp(name->GetName(),"missing")){
	sprintf(mname,"%s",name->GetName());
      }
      
      
      sprintf(h_title,"Icc;%d",moi[i]+1);
      TGraph *histo = (TGraph*) strun->Get(h_title)->Clone();
      pad_plot->cd(i+1);
      histo->Draw("AL");
      histo->GetHistogram()->SetTitleOffset(1.0,"X");
      histo->GetHistogram()->SetTitleOffset(1.2,"Y");
      histo->GetHistogram()->SetXTitle("Vthr (mV)");
      histo->GetHistogram()->SetYTitle("Icc (mA)");
      histo->GetHistogram()->Draw();
      histo->Draw("L");
      
      sprintf(h_title,"Idd;%d",moi[i]+1);
      TGraph *histo = (TGraph*) strun->Get(h_title)->Clone();
      pad_plot->cd(4+i);
      histo->Draw("AL");
      histo->GetHistogram()->SetTitleOffset(1.0,"X");
      histo->GetHistogram()->SetTitleOffset(1.2,"Y");
      histo->GetHistogram()->SetXTitle("Vthr (mV)");
      histo->GetHistogram()->SetYTitle("Idd (mA)");
      histo->GetHistogram()->Draw();
      histo->Draw("L");
      
    }
  }
  c6->Update();
  strun->Close();
  ps->Close();

  return;
}
