void Longterm_fit(){

  Int_t i,nread,ndata;
  Char_t fname[256],line[1024];
  Float_t time[500],occ[12][500],tfirst;

  TCanvas* c3 = new TCanvas ("c3","NO",1100,750);
  c3->cd();
  c3->Clear();
  c3->Divide(4,3,0,0);

  sprintf(fname,"D:\\sctvar\\results\\0009_NOvsT_20010822.txt");
  FILE* input=fopen(fname,"r");

  if(!input){
    printf("can't open input file\n");
    return;
  }

  nread=1;
  for(i=0;i<13 && nread==1;i++)
    nread = fscanf(input,"%s",line);
  
  ndata=0;
  while(nread==1&& ndata<500){
    nread = fscanf(input,"%f",time+ndata);
    if(ndata==0) tfirst = time[0];
    time[ndata] -= tfirst;
    for(i=0;i<12 && nread==1;i++){
      nread = fscanf(input,"%f",&occ[i][ndata]);
      //occ[i][ndata] = TMath::Log(occ[i][ndata]);
    }
    ndata++;
  }

  fclose(input);
  printf("read %d data\n",--ndata);

  TF1* f1;
  sprintf(fname,"f1");
  f1 = new TF1(fname, "expo", time[0]-1., time[ndata-1]+1.);
  f1->SetLineColor((Color_t) 2);

  TGraph* gr[12];
  for(i=0;i<12;i++){
    c3->cd(i+1);
    gPad->SetLogy(1);
    gr[i] = new TGraph(ndata,time,occ[i]);
    sprintf(fname,"Noise Occupancy chip %d",i);
    gr[i]->SetTitle(fname);
    gr[i]->SetMarkerStyle(20);
    gr[i]->SetMarkerSize(1);
    gr[i]->SetMarkerColor((Color_t) 1);
    gr[i]->Draw("AP");
    //f1->SetRange(time[0],5.);//time[ndata-1]);
    //gr[i]->Fit("f1",""); // no graphics, quiet mode
  }

  return;
}
