void NOvsQ(Int_t run, Int_t scan, Int_t log=0){
  #include <parameters.h>
  Int_t i, nbins, link, chip, ngood, ngood2, nmod, nsum, nread, id,newlog;
  Float_t x[200],y[200], content, qthr, evcnt, dy[200],dy2[200],dx[200];
  Float_t en[MAX_MODULES*MAX_CHIPS*MAX_LINKS],qn[MAX_MODULES*MAX_CHIPS*MAX_LINKS],chipid[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Float_t mvthr,data;
  char h_name[32], line[1024],mname[MAX_MODULES][32];
  Char_t texta[1024],textb[1024];
  TCanvas* c3 =0;
  c3= new TCanvas ("c3","NO",1100,750);

  gROOT->LoadMacro("stan_util.cpp");
  gROOT->LoadMacro("ToolBox.cpp");
  gROOT->LoadMacro("mV2fC.cpp");
  gROOT->LoadMacro("fC2mV.cpp");
  //gROOT->LoadMacro("PosProjY.cpp");
  gROOT->LoadMacro("estand_secind_data.cpp");

  sprintf(line,"%sNOvsQ%d_%d.ps",PS_DIRECTORY,run,scan);
  ps = new TPostScript(line,112);

  TFile* strun;
  sprintf(line,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan);
  strun = new TFile(line);

  nmod = 0;
  nsum = 0;
  for(id=0;id<MAX_MODULES;id++){

    sprintf(h_name,"h_scan0;%d",id+1);
    TH2F* hscan0 = (TH2F*)strun->Get(h_name);
    sprintf(h_name,"h_scan1;%d",id+1);
    TH2F* hscan1 = (TH2F*)strun->Get(h_name);
    sprintf(h_name,"h_scan_evcnt;1");
    TH1F* hevcnt = (TH1F*)strun->Get(h_name);
    
    sprintf(h_name,"ModuleName;%d",id+1);
    if(id==0){
      TObjString* time  = (TObjString*)strun->Get("Time");
      TObjString* place = (TObjString*)strun->Get("Place");
    }
    TObjString* name = (TObjString*)strun->Get(h_name);
    if(name)
      sprintf(mname[id],"%s",name->GetName());
    else
      break;
    if(!strcmp(mname[id],"missing")) break;

    nmod++;

    TF1* f1;
    sprintf(h_name,"f1");
    f1 = new TF1(h_name, "pol1",  0, 3);
    
    ps->NewPage();
    c3->cd();
    c3->Clear();
    
    pad_t = new TPad("pad_t","Text",        0.00,0.90,1.00,1.00,33);
    pad_p = new TPad("pad_p","Projections",   0.00,0.00,1.00,0.90,33);
    pad_t->Draw();
    pad_p->Draw();
    pad_p->Divide(4,3,0,0);
    
    TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
    t1->SetFillColor(10);
    t1->SetTextAlign(13);
    t1->SetTextSize(0.3);
    t1->SetTextColor(4);
    sprintf(line,"ATLAS SCT Noise Occupancy");
    sprintf(line,"%s  -  log n.o. vs Qthr2",line);
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    t1->AddText(line);
    
    sprintf(line,"Run %d   Scan %d   Module %d (%s)", run, scan, id, mname[id]);
    t1->AddText(line);
    pad_t->cd();
    t1->Draw();
    
    pad_p->cd();
    for(link=0;link<MAX_LINKS;link++){
      for(chip=0;chip<MAX_CHIPS;chip++){
	
	if(link==0)
	  TH1F* tmp = (TH1F*) hscan0->ProjectionY("tmp",chip*128,(chip+1)*128-1);
	//TH1F* tmp = (TH1F*) PosProjY(hscan0,chip*128,(chip+1)*128-1);
	else
	  TH1F* tmp = (TH1F*) hscan1->ProjectionY("tmp",chip*128,(chip+1)*128-1);
	//TH1F* tmp = (TH1F*) PosProjY(hscan1,chip*128,(chip+1)*128-1);
	tmp->Scale(1.0/128);
	nbins = tmp->GetNbinsX();
	ngood=0;
	ngood2=0;
	for(i=0;i<nbins;i++){
	  content = (Float_t) tmp->GetBinContent(i+1);
	  evcnt = (Float_t) hevcnt->GetBinContent(i+1);
	  if(evcnt<1) evcnt=1;
	  qthr = tmp->GetBinCenter(i+1);
	  mvthr = (Float_t) fC2mV(mname[id],chip+6*link,(Float_t) qthr);
	  /* 2.5mV  DAC bit */
	  mvthr = (Float_t) ((int)(((float)mvthr+1.25)/(float)2.5)) * (float)2.5;
	  qthr = (Float_t) mV2fC(mname[id],chip+6*link,(Float_t) mvthr);
	  if(content>5e-9){
	    x[ngood] = qthr;
	    if(log){
	      y[ngood] = TMath::Log(content);
	      dy[ngood] = TMath::Sqrt((1-content)/evcnt/content);
	    }
	    else{
	      y[ngood] = content;
	      dy[ngood] = TMath::Sqrt((1-content)/evcnt*content);
	    }
	    ngood++;
	  }
	  else
	    break;
	}
	
	if(ngood>0) {  
	  TGraphErrors* gr = new TGraphErrors(ngood,x,y,dx,dy);
	  pad_p->cd((link*6)+chip+1);
	  
	  sprintf(h_name,"Noise Occupancy link %d chip %d", link, chip);
	  gr->SetTitle(h_name);
	  gr->SetMarkerStyle(20);
	  gr->SetMarkerSize(1);
	  gr->SetMarkerColor((Color_t) 1);
	  if(log){
	    gr->SetMinimum(-20);
	    gr->SetMaximum(0.5);
	  }
	  else{
	    gr->SetMinimum(-0.05);
	    gr->SetMaximum(1.05);
	  }	    
	  gr->Draw("AP");
	  gr->GetXaxis()->SetTitle("Qthr2, fC^2");
	  if(log)
	    gr->GetYaxis()->SetTitle("Ln(occupancy)");
	  else
	    gr->GetYaxis()->SetTitle("Occupancy");
	  gr->Draw("AP");
	  nsum++;
	}
      }
    }
    
    c3->Update();

  // read test stand data

    estand_secind_data(1,mname[id],line);
    sprintf(line,"J:\\www\\barrel_web\\ind_mod\\%s\\%s",mname[id],line);
    FILE* input=fopen(line,"r");
    if(!input){
      printf("cannot open e-stand data-file %s\n",line);
      return;
    }
    nread=1;
    chip=-1;
    newlog = 0;
    while(nread==1 && chip<11){
      strcpy(textb,texta);
      nread = fscanf(input,"%s",texta);
      if(!strcmp(texta,"Chip") && (!strcmp(textb,"innse_err") || !strcmp(textb,"innse") || !strcmp(textb,"comment") 
				   || (chip<11 && chip>=0))){
      //if(!strcmp(texta,"Chip") && (!strcmp(textb,"innse_err") || !strcmp(textb,"innse") || chip<11)){
	if(!strcmp(textb,"comment")) newlog=1;
	nread = fscanf(input,"%d:",&chip);
	nread = fscanf(input,"%s",texta);
	nread = fscanf(input,"%s",texta);
	nread = fscanf(input,"%s",texta);
	nread = fscanf(input,"%s",texta);
	nread = fscanf(input,"%s",texta);
	if(newlog){
	  nread = fscanf(input,"%s",texta);
	  nread = fscanf(input,"%s",texta);
	}
	nread = fscanf(input,"%f",&data);
	if(chip>=0 && chip<MAX_CHIPS*MAX_LINKS)
	  en[id*MAX_CHIPS*MAX_LINKS+chip] = data;
      }
    }
    fclose(input);

  }

  ps->Close();
  strun->Close();

  return;
}
