#include "Evtree.h"                   //***
#include "parameters.h"               //***
#include "TMath.h"                    //*** 
#define NTREES 5
  
void OPE_10M (Int_t mod = 1) {

  //finds gamma for all chips of chosen module
  
  FILE* txtout;
  Char_t fname[256];
  
  Char_t line[1024],filename[70],module0[30],module1[30], filestore[50],mod_name[50],mname[MAX_MODULES][50];
  Int_t nmod, nevt, chip2, nchips=MAX_CHIPS*MAX_LINKS, tree_indx, nev_tot=0;
  Int_t runno[NTREES]={788,788,788,789,789};
  Int_t scanno[NTREES]={1,2,3,1,2};
  
  Double_t hpe[12], hpe2[12];
  
  Double_t ahpe[12], prob[12];
  Double_t varcalc[12], sum[12];
  Double_t sumsqd[12], ahpesqd[12];
  Double_t varobs[12];
  
  Evtree* m[NTREES];
  TTree* tree[NTREES];
  
  TDatime *dt = new TDatime;
  printf("starting program at %d\n",dt->GetTime());
  
  TFile* f[NTREES];

  //open all data files
  
  for(tree_indx = 0;tree_indx<NTREES;tree_indx++){

    sprintf(filename,"%sstrun%d_%d.root",ARCH_DIRECTORY,runno[tree_indx],scanno[tree_indx]); //***
    f[tree_indx] = new TFile(filename);
    
    // find module - takes this info from the first tree loaded
    
    if(tree_indx == 0){
      
      TObjString* time  = (TObjString*)f[tree_indx]->Get("Time");
      TObjString* place = (TObjString*)f[tree_indx]->Get("Place");
  
      sprintf(mod_name,"ModuleName;%d",mod+1);
      TObjString* name = (TObjString*)f[tree_indx]->Get(mod_name);
      if(name){
	sprintf(mname[mod],"%s",name->GetName());
	if(!strcmp(mname[mod],"missing")) break;
	nmod++;
      }
      else
	break;

    }
    sprintf(module0,"EvTree_m%d",mod);
    tree[tree_indx] = (TTree*)gDirectory->Get(module0);
    m[tree_indx] = new Evtree(tree[tree_indx]);
    
    nevt = tree[tree_indx]->GetEntries();
    nev_tot += nevt;
    
    printf("Tree %d: found module %s with %d events\n",tree_indx,mname[mod], nevt);
    
  }

  printf("Total of %d events\n",nev_tot);

  // find masked strips

  Char_t texta[64],textb[64];
  Int_t mask_strip[200], i=1,nmask=0;
  Bool_t notmasked;
  FILE *in;

  sprintf(fname,"D:\\sctvar\\config\\%s.mask",mname[mod]);
  in = fopen(fname,"r");
  if(!in){
    printf("Can't open mask file %s\n",fname);
    return;
  }

  strcpy(texta," ");
  while(i==1 && nmask<200){
    strcpy(textb,texta);
    i = fscanf(in,"%s",texta);
    if(texta[0]=='#' && i==1){
      sscanf(textb,"%d",mask_strip+nmask);
      nmask++;
    }
  }

  fclose(in);

  printf("Found the following strips masked: ");
  for(i=0;i<nmask;i++)
    printf("%d ",mask_strip[i]);
  printf("\n\n");

  // open TXT output file
  
  sprintf(fname,"%sgammas_10M_%s.txt",RESULTS_DIRECTORY,mname[mod]);      //***
  txtout = fopen(fname,"w");
  if(!txtout){
    printf("ERROR opening output file %s!\n",fname);
    return;
  }

  //nevt = 100;
    
  //now loop over the events and the chips

  for(Int_t chip=0;chip<12;chip++){
    sum[chip]=0.0;
    sumsqd[chip]=0.0;
  }
   
  //start the event looop

  for(tree_indx =0; tree_indx<NTREES;tree_indx++){ // need to loop over trees now
    for(Int_t ev=0;ev<nevt;ev++){ 
    
      //load array
    
      m[tree_indx]->GetEntry(ev);
      
      //get number of hits per chip in this event, hpe

      for(chip=0;chip<12;chip++){ //ALARM!!!

	hpe[chip]=0.0;
	for(Int_t strip=0;strip<MAX_TARGETS;strip++){

	  // masking information!!! Perhaps not the best way to do it //***

	  notmasked=kTRUE;
	  for(i=0;i<nmask;i++)
	    notmasked &= ((chip * 128)+ strip != mask_strip[i]);
	  //if((chip * 128)+ strip != 68 && (chip*128) + strip != 805){
	  if(notmasked){
	  
	    if((chip)<MAX_CHIPS){
	      if(m[tree_indx]->strm0[strip+(chip*MAX_TARGETS)]) hpe[chip]+=1.0;
	    }else{
	      if(m[tree_indx]->strm1[strip+((chip-6)*MAX_TARGETS)]) hpe[chip]+=1.0;
	    }
	  }
	  //else if (ev==0)
	    //printf("Ignoring strip %d\n",(chip * 128)+ strip);
	}
	
	sum[chip]=sum[chip]+hpe[chip];
	sumsqd[chip]=sumsqd[chip]+(hpe[chip]*hpe[chip]);
	
      }
      if((ev+1)%100000==0) printf("finished event %d \n",ev+1);
    }
    printf("Finished tree %d\n",tree_indx);
  }
  
  for(tree_indx = 0;tree_indx<NTREES;tree_indx++)
    f[tree_indx]->Close();
  
  nevt = nev_tot;
  
  //new end part to find alpha only

  for(chip=0;chip<12;chip++){ 
    
    ahpe[chip]=sum[chip]/(Double_t)nevt;
    
    ahpesqd[chip]=sumsqd[chip]/(Double_t)nevt;
    
    prob[chip]=ahpe[chip]/MAX_TARGETS;
    
    varcalc[chip]=ahpe[chip]*(1-(ahpe[chip]/MAX_TARGETS));
    
    varobs[chip]=ahpesqd[chip]-(ahpe[chip]*ahpe[chip]);

    Double_t alpha = varobs[chip]-varcalc[chip];

    //get error on Nebar

    Double_t Nebar_err = (TMath::Sqrt(varobs[chip]))/(TMath::Sqrt((Double_t)nevt));

    //get error on var

    Double_t varobs_err = (2 * varobs[chip]) / (TMath::Sqrt (2.0* (Double_t)nevt));
    
    //get error on alpha
    
    Double_t alpha_err = (varobs_err * varobs_err) + (Nebar_err * Nebar_err) + (2 * Nebar_err * varobs_err);
    
    alpha_err = TMath::Sqrt(alpha_err);
    
    fprintf(txtout,"Chip: %d  Est Occu.: %le  Var_obs: %lf  Var_calc: %lf  Alpha %lf  Alpha error: %lf\n",
	    chip,prob[chip], varobs[chip],varcalc[chip],alpha, alpha_err);
    
  }
  fclose(txtout);
  
  printf("num of events  %d \n", nevt);

  TDatime *dt2 = new TDatime;
  printf("finished program at %d\n",dt2->GetTime());
  
  return;
}
