void cmn_chmx(Int_t runno, Int_t scanno) {

  gROOT->Reset();
  
#include "../macros/systest/Evtree.h"
#include "../macros/parameters.h"

#define MAX_MOD 12

  Int_t MAX_CHIPS = MAX_MOD*12, nevt;
 

  Char_t filename[70],module0[30],module1[30], filestore[50],mod_name[50],mname[12][50];

  // define histogram

  TH2F *histo = new TH2F("histo","correlated noise chip by chip",MAX_CHIPS,-0.5,MAX_CHIPS-0.5,MAX_CHIPS,-0.5,MAX_CHIPS-0.5);
  histo->SetStats(kFALSE);

  //loop over modules (over the files and trees)

  Evtree* m[MAX_MOD];
  TFile* f[MAX_MOD];


  Float_t cont, sum[144], hpe[144][10000];
 
  Float_t mean[144],sd[144]; 

  Double_t sumsqd[144],meansqs[144];

  for(Int_t mod=0;mod<MAX_MOD;mod++){
    
    sprintf(filename,"%sstrun%d_%d_%d.root",DATA_DIRECTORY,runno,scanno,mod);
    f[mod] = new TFile(filename);

    sprintf(mod_name,"ModuleName;%d",1);

    
    TObjString* name = (TObjString*)f[mod]->Get(mod_name);    
    sprintf(mname[mod],"%s",name->GetName());
    printf("%s\n",mname[mod]);

    sprintf(module0,"EvTree;%d",1);
    
    printf("%s\n",".");
    
    TTree* tree = (TTree*)gDirectory->Get(module0);
    
    printf("%s\n","..");
    
    m[mod] = new Evtree(tree);
    
    nevt = tree->GetEntries();
    printf("Tree for module %s has %d entries\n",mname[mod],nevt);

    for(Int_t chip=0;chip<12;chip++){
      
      sum[(mod*12)+chip]=0.0; 
      sumsqd[(mod*12)+chip]=0.0;
      

      for(Int_t ev=0;ev<nevt;ev++){

	hpe[(mod*12)+chip][ev]=0.0;

	m[mod]->GetEntry(ev);
		
	for(Int_t strip=0;strip<128;strip++){
	  if(chip<6){
	    cont = m[mod]->strm0[strip+(chip*128)];
            hpe[(mod*12)+chip][ev]=hpe[(mod*12)+chip][ev]+cont;
            //sum[(mod*12)+chip]=sum[(mod*12)+chip]+cont;
	    //sumsqd[(mod*12)+chip]=sumsqd[(mod*12)+chip]+(hpe[(mod*12)+chip][ev])**2;
	  }else{
	    cont = m[mod]->strm1[strip+((chip-6)*128)];
	    hpe[(mod*12)+chip][ev]=hpe[(mod*12)+chip][ev]+cont;
	    //sum[(mod*12)+chip]=sum[(mod*12)+chip]+cont;
	    //sumsqd[(mod*12)+chip]=sumsqd[(mod*12)+chip]+(hpe[(mod*12)+chip][ev])**2; 
	  }
	}
	sum[(mod*12)+chip]=sum[(mod*12)+chip]+hpe[(mod*12)+chip][ev];
	sumsqd[(mod*12)+chip]=sumsqd[(mod*12)+chip]+(Double_t)(hpe[(mod*12)+chip][ev])**2.0;
        //printf("%f\n",sumsqd[(mod*12)+chip]);
      }
       
      //find mean for chips
    
      mean[(mod*12)+chip]=sum[(mod*12)+chip]/(Float_t)nevt;
      //printf("%f\n",mean[(mod*12)+chip]);
    
      //find mean of squares for chip

      meansqs[(mod*12)+chip]=sumsqd[(mod*12)+chip]/(Float_t)nevt;

      //find sd

      sd[(mod*12)+chip]=((Float_t)meansqs[(mod*12)+chip]-(mean[(mod*12)+chip])**2)**0.5;
      //printf("%f\n",sd[(mod*12)+chip]);
    }
    f[mod]->Close();
    f[mod]->Delete();
  }

  //now need two loops for the correlation

  for(Int_t chip0=0;chip0<MAX_CHIPS;chip0++){
    for(Int_t chip1=0;chip1<MAX_CHIPS;chip1++){

      Float_t prodsum=0.0;
      for(ev=0;ev<nevt;ev++){
	Float_t diff0=hpe[chip0][ev]-mean[chip0];
	Float_t diff1=hpe[chip1][ev]-mean[chip1];
	Float_t prod = diff0*diff1;
	prodsum=prodsum+prod;
      }
      Float_t expprod=prodsum/(Float_t)nevt;
      
      Float_t correl[144][144];

      if(sd[chip0] ==0 || sd[chip1]==0){
	correl[chip0][chip1]=0.0;
      }else{
	correl[chip0][chip1] = expprod/(sd[chip0]*sd[chip1]);
      }
      //printf("%s %d %d %s %f\n","correlation between chips ",chip0, chip1, "is ", correl[chip0][chip1]);
      histo->Fill(chip0,chip1,correl[chip0][chip1]);  
      
    }
  }

  sprintf(filestore,"%scmn_%d_%d.root",DATA_DIRECTORY,runno,scanno);
  TFile store(filestore,"recreate");
  histo->Write();
  store->Close();
  return;
}
