#include <parameters.h>

void dL1A_scan(Int_t runa, Int_t scana, Int_t runb, Int_t scanb){

  TFile *strun[2];
  Int_t runs[2], scans[2],i,j,k;
  runs[0]=runa;
  runs[1]=runb;
  scans[0]=scana;
  scans[1]=scanb;
  Char_t fname[256],modname[20],mname[MAX_MODULES][20],line[1024];
  TH1F *sigma[2][2], *mean[2][2];
  TH2F frames[2],framem[2];
  frames[0] = TH2F("fr1","Sigma link 0",12,0,768,10,0,.3);
  framem[0] = TH2F("fr2","Mean link 0",12,0,768,10,-.2,.6);
  frames[1] = TH2F("fr1","Sigma link 1",12,0,768,10,0,.3);
  framem[1] = TH2F("fr2","Mean link 1",12,0,768,10,-.2,.6);
  TObjString *name, *place, *time;

  TCanvas *can;
  can = new TCanvas("sigma","sigma",1100,750);
  gStyle->SetOptStat(0);
  gStyle->SetOptFit(0);      
  can->cd();
  can->Clear();
  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
  pad_text->Draw();
  pad_plot->Divide(2,2);
  pad_plot->Draw();
  

  for(i=0;i<2;i++){
    sprintf(fname,"%sstrun%d_%d.root",DATA_DIRECTORY,runs[i],scans[i]);
    strun[i] = new TFile(fname);
  }

  time   = (TObjString*) strun[0]->Get("Time");
  place  = (TObjString*) strun[0]->Get("Place");
  for(i=0;i<MAX_MODULES;i++){
  //for(i=0;i<2;i++){
    sprintf(modname,"ModuleName;%d",i+1);
    name  = (TObjString*) strun[0]->Get(modname);
    if(name){
      if(strcmp(name->GetName(),"missing")){
	sscanf(name->GetName(),"%s", mname[i]);
      }
      else
	  break;
    }
    else
      break;

    pad_text->cd();
    TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
    t1->SetFillColor(10);
    t1->SetTextAlign(13);
    t1->SetTextSize(0.3);
    t1->SetTextColor(4);
    sprintf(line,"ATLAS SCT: Successive L1As");
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    t1->AddText(line);
    sprintf(line,"Reference (single L1A): run %d scan %d; run %d, scan %d double L1A only reading data from 2nd L1A", 
	    runs[0],scans[0],runs[1],scans[1]);
    t1->AddText(line);
    sprintf(line,"Sigma and mean of occupancy scan   module %d %s",i,mname[i]);
    t1->AddText(line);
    t1->Draw();
    can->Update();

    for(k=0;k<2;k++){
      pad_plot->cd(k+1);
      frames[k]->Draw();
      sprintf(fname,"h_sigma%d;%d",k,i+1);
      for(j=0;j<2;j++){
	sigma[j][k] = (TH1F*) strun[j]->Get(fname);
	sigma[j][k]->SetLineColor(1+j);
	sigma[j][k]->SetMarkerColor(1+j);
	sigma[j][k]->SetMarkerStyle(20);
	sigma[j][k]->SetMarkerSize(.5);
	sigma[j][k]->Draw("SAMEL");
      }

      pad_plot->cd(3+k);
      framem[k]->Draw();
      sprintf(fname,"h_mean%d;%d",k,i+1);
      for(j=0;j<2;j++){
	mean[j][k] = (TH1F*) strun[j]->Get(fname);
	mean[j][k]->SetLineColor(1+j);
	mean[j][k]->SetMarkerColor(1+j);
	mean[j][k]->SetMarkerStyle(20);
	mean[j][k]->SetMarkerSize(.5);
	mean[j][k]->Draw("SAMEL");
      }
    }
    can->Update();

    printf("Type any nonsense to continue:  ");
    scanf("%s",fname);
  }
  
  for(i=0;i<2;i++)
    strun[0]->Close();

  return;
}
