void hitsvst(Int_t runno, Int_t scanno, Int_t mod, Int_t chip) {

  gROOT->Reset();
  
#include "systest/Evtree.h"
#include "parameters.h"
#define NCHIPS 12

  Char_t line[1024],filename[70],module0[30],module1[30], filestore[50],mod_name[50],mname[MAX_MODULES][50];
  Int_t nmod, totchips, nevt, chip, chip2, strip, mod, mod2,indx;

  Bool_t hita, hitb;

  Float_t sum, avghit[5000],hittime[5000];
  
  TH1F* histo[MAX_MODULES][NCHIPS];

  Evtree* m[MAX_MODULES];
  TTree* tree[MAX_MODULES];

  TDatime *dt = new TDatime;
  printf("starting program at %d\n",dt->GetTime());

  //open the file

  TFile* f;
  sprintf(filename,"%sstrun%d_%d.root",DATA_DIRECTORY,runno,scanno);
  f = new TFile(filename);
  

  TObjString* time  = (TObjString*)f->Get("Time");
  TObjString* place = (TObjString*)f->Get("Place");

  sprintf(mod_name,"ModuleName;%d",mod+1);
  TObjString* name = (TObjString*)f->Get(mod_name);
  if(name){
    sprintf(mname[mod],"%s",name->GetName());
    if(!strcmp(mname[mod],"missing")) break;
    nmod++;
  }
  else
    return;

  sprintf(module0,"EvTree_m%d",mod);
  tree[mod] = (TTree*)gDirectory->Get(module0);
  m[mod] = new Evtree(tree[mod]);
   
  nevt = tree[mod]->GetEntries();
  printf("found module with trees with %d entries\n",nevt);
  //nevt=480000;

  //start the event looop

  sum=0;
  indx=0;
  for(Int_t ev=0;ev<nevt;ev++){
    
    //load arrays
    m[mod]->GetEntry(ev);
      
    //get hits per chip in this event
    
    for(strip=0;strip<MAX_TARGETS;strip++){
      if(chip<MAX_CHIPS)
	hita = m[mod]->strm0[strip+(chip*MAX_TARGETS)];
      else
	hita = m[mod]->strm1[strip+((chip-MAX_CHIPS)*MAX_TARGETS)];
      if(hita) sum++;
    }
    
    //    if(sum>10) printf("Event %d has %.0f hit strips\n",ev,sum);
    if((ev+1)%600==0){
      avghit[indx]=sum/600.;
      hittime[indx]=(Float_t)indx;
      printf("%.0f %.4f\n",hittime[indx],avghit[indx]);
      indx++;
      sum=0;
    }
    
  }
  TGraph *gr;
  gr = new TGraph(indx,hittime,avghit);
  gr->SetMarkerStyle(20);
  gr->Draw("ALP");

  /*
  TDatime *dt2 = new TDatime;
  printf("finished analysis at %d\n",dt2->GetTime());

  sprintf(filename,"%sgamma_%d_%d.root",RESULTS_DIRECTORY,runno,scanno);
  TFile out(filename,"recreate");
  for(mod=0;mod<nmod;mod++){
    TObjString * mns = new TObjString(mname[mod]);
    mns->Write("ModuleName");
    for(chip=0;chip<NCHIPS;chip++){
      sprintf(module0,"gh_%d_%d",mod,chip);
      histo[mod][chip]->Write(module0);
    }
  }
  sprintf(module0,"%d",nevt);
  TObjString * nevo = new TObjString(module0);
  nevo->Write("Events");
  if(time)  time->Write("Time");
  if(place) place->Write("Place");
  out->Close();
  */
  return;
}
