Int_t get_val(char* line, Int_t index, double* val){

  // convert next element of data row "line" to type double
  // (CINT sscanf is limited to <43 elements, hence this approach)

  char substring[20];

  sscanf(line+=index,"%s ",substring);
  sscanf(substring,"%lf",val);
  return 1 + strlen(substring);
}

void stan_kwikrc(short moi, short loi, short run, short start_scan){
  // Version 0.11 BJG, 30.04.02   Fix some memory leaks

  char f_name[64], h_name[32], h_name0[32], h_name1[32], out_fname[64];
  char labelt[10],titlet[128],scan_name[64],unit[12];
  char title1[32], line[256];
  double mean;
  float sigma, chisq;
  float i_mean, i_sigma;
  float scan_start, scan_stop, scan_step;
  float scan_lo, scan_hi, scan_range;
  int  chip, i, j, n, scan_type, scan_max_points;

  // Locality options now moved to stan_util.cpp

// Options which change macro output
  int postscript = 1;

// Global style variations

  gStyle.SetPaperSize(20,26); // I find that the postscript output
                              // is mangled without this line - 
                              // although this size (A4) should in
                              // principle be the default...
  gStyle.SetMarkerStyle(21);
  gStyle.SetMarkerSize(0.3);
  gStyle.SetOptFit(0);
  gStyle.SetOptStat(10);
  gStyle.SetTitleW(0.6);

// Open file, or obtain pointer to histogram in memory

  printf("stan_kwikrc called for module %d link %d\n",moi,loi);
  
    scan_max_points = 10;
//    n = 640;
    n = 400;

  // load data

  float ly0[64];
  float ly1[64];
  float ly2[64];
  float ly3[64];
  float x[64];
  float xe[64];
  float y[768][64];
  float ye[768][64];

  for(j=0;j<scan_max_points;j++){
     x[j]=1.0+(j*0.5); 
    if (RAL) sprintf(f_name,"M:\\sctvar\\data\\strun%d_%d_%d_%d.fit",run,(start_scan+j),moi,loi);
    else sprintf(f_name,"D:\\sctvar\\data\\strun%d_%d_%d_%d.fit",run,(start_scan+j),moi,loi);
    FILE* fitfile = fopen(f_name,"r");

    if(fitfile==NULL) printf("Could not open fit file %s\n",f_name);
    else {
      printf("File %s opened for reading\n",f_name);

      i=0;

      fgets(line,1024,fitfile);
      while(fgets(line,1024,fitfile) != NULL){
        index = 10;
        get_val(line,index,&mean);
        y[i][j]=(float)mean;
        i++;
      }
    fclose(fitfile);
    }
  }

// titles for graphs - might as well do this now.

    sprintf(title1,"%s - scurves Module %d Link %d", scan_name, moi, loi);

  float ly0[64];
  float ly1[64];
  float ly2[64];
  float ly3[64];
  float x[64];
  float xe[64];
  float y[768][64];
  float ye[768][64];

  scan_start = 1.0;
  scan_stop  = 5.0;
  scan_step  = 0.5; 

printf("scan_start %f, stop %f, npoints %f\n",scan_start, scan_stop, scan_max_points);

//  for(i=0;i<scan_max_points; i++){
//    x[i] = scan_start + (i* scan_step);
//    xe[i] = 1;
//  }

  x[0] = 1.00;
  x[1] = 1.25;
  x[2] = 1.50;
  x[3] = 1.75;
  x[4] = 2.00;
  x[5] = 2.50;
  x[6] = 3.00;
  x[7] = 3.50;
  x[8] = 4.00;
  x[9] = 4.50;

  if(postscript){
    if(RAL) sprintf(out_fname,"M:\\sctvar\\data\\strcrun%d_%d_%d_%d.ps",run,scan_start,moi,loi);
    else    sprintf(out_fname,"D:\\sctvar\data\\strcrun%d_%d_%d_%d.ps",run,scan_start,moi,loi);

    TPostScript *ps = new TPostScript(out_fname,112);
    printf("Generating postscript file %s\n",out_fname);
    ps->NewPage();
  }

  // gr1 = new TGraphErrors(23,x,y,xe,ye);

// New canvas for scurves
  TCanvas* crc=new TCanvas ("crc","stan_kwikrc",1100,750);
  pad_t0 = new TPad("pad_t0","title",               0.00,0.920,1.00,1.000,33);
  pad_c0 = new TPad("pad_c0","Response Curves",     0.00,0.000,1.00,0.910,33);

  pad_c0->Divide(3,2);

  pad_t0->Draw();
  pad_c0->Draw();

  TPaveText *ttitle = new TPaveText(0.0,0.05,1.0,0.95);
  ttitle->SetFillColor(10);  
  ttitle->SetTextAlign(13);
  ttitle->SetTextSize(0.8);
  ttitle->SetTextColor(4);
    sprintf(titlet,"Module %d Link %d Run %d StartScan %d - %s from %3.2f%s to %3.2f%s in %3.2f%s steps, total %d points ",
      moi,loi,run,start_scan,scan_name,scan_start,unit,scan_stop,unit,scan_step,unit,scan_max_points);
  ttitle->AddText(0,0.0,titlet);
  pad_t0->cd();
  ttitle->Draw();


  TH2F *hrc0 = new TH2F("rc0","Response Curves chip0",2,0,scan_stop,2,0,n);
  TH2F *hrc1 = new TH2F("rc1","Response Curves chip1",2,0,scan_stop,2,0,n);
  TH2F *hrc2 = new TH2F("rc2","Response Curves chip2",2,0,scan_stop,2,0,n);
  TH2F *hrc3 = new TH2F("rc3","Response Curves chip3",2,0,scan_stop,2,0,n);
  TH2F *hrc4 = new TH2F("rc4","Response Curves chip4",2,0,scan_stop,2,0,n);
  TH2F *hrc5 = new TH2F("rc5","Response Curves chip5",2,0,scan_stop,2,0,n);

  pad_c0->cd(1);
  hrc0->SetXTitle("Q (fC)");
  hrc0->Draw();

  pad_c0->cd(2);
  hrc1->SetXTitle("Q (fC)");
  hrc1->Draw();

  pad_c0->cd(3);
  hrc2->SetXTitle("Q (fC)");
  hrc2->Draw();

  pad_c0->cd(4);
  hrc3->SetXTitle("Q (fC)");
  hrc3->Draw();

  pad_c0->cd(5);
  hrc4->SetXTitle("Q (fC)");
  hrc4->Draw();

  pad_c0->cd(6);
  hrc5->SetXTitle("Q (fC)");
  hrc5->Draw();


  crc->Update();

  for(chip=0;chip<6;chip++){          // chip
    for(i=0;i<128;i++){               // channel
      for(j=0;j<scan_max_points;j++){ // scan
        ly0[j]= y[(128*chip)+i][j];
      }

      gr0 = new TGraph(scan_max_points,x,ly0);
    
      pad_c0->cd(1+chip);
      gr0->SetMarkerStyle(6);
      gr0->SetMarkerColor(i);
      gr0->SetLineColor(i);
      gr0->Draw("LP");

    }
    crc->Update();
  }

  if(postscript) {
    ps->Close();
    delete ps;
  }
}

