/* include/v262_lib.h    V262 Readout library declarations  */

void v262_init(int base_address);
void v262_map(int vme_addr, int *base_address);
void v262_unmap(int base_address);
void v262_reset(int base_address);

void v262_read_NIM_level(int base_address, unsigned short *reg);
void v262_write_NIM_pulse(int base_address, unsigned short reg);
void v262_write_NIM_level(int base_address, unsigned short reg);
void v262_write_ECL_level(int base_address, unsigned short reg);

#define V262_RD_NIML 0x0a
#define V262_WR_NIMP 0x08
#define V262_WR_NIML 0x06
#define V262_WR_ECLL 0x04

#define V262_CHECK 0xfa
#define V262_MANUF 0xfc
#define V262_MODID 0xfe

#define V262_AM_CODE 0x39   // Standard (A24) user access
#define V262_SIZE 0x100


