//
// HybridColdTest.cpp   Macro for Cold Tests of Hybrids
//
// Version 0.1  DGC  12/07/02
//

#ifdef DATA_DIRECTORY
  // do not reload parameters.h
#else
  // must load parameters.h
#include <parameters.h>
#endif

#include "TLTT.h"

void HybridColdTest(Int_t small, Int_t big, Int_t total) {

  // Creates and does a Hybrid Long Term Test

  gROOT->ProcessLine(".L TLTT.cpp") ;
  TLTT *t = new TLTT(small,big,total) ;
  t->HybridColdTest() ;
  delete t;
}

void HybridColdTest() {
  // Current/temperature monitored every 5 min
  // Confirmation Test every 2 hours
  // Characterisation Test at the end
  // Standard duration of test 10h

  HybridColdTest(300,7200,36000) ;
}
