void LTPostRadTest(Double_t small_interval, Double_t big_interval){

  //
  // hit STOP to move to the next scan
  // hit ABORT to end the test
  // PWP 13.12.00
  //

  Char_t fname[64];
  Double_t small_loop_end, big_loop_end;
  Int_t n;

  sprintf(fname,"D:\\sctvar\\data\\DCSntuple_%d.root",e->runnum);

  TFile* outfile = new TFile(fname,"CREATE");
  TModuleDCS* dcs;

  TTree* DCSTree = new TTree("DCSTree","DCSTree");
  DCSTree->Branch("DCSBranch","TModuleDCS",&dcs,8000,1);

  TStopwatch* timer = new TStopwatch();
  Double_t start_time = timer->GetRealTime();


  Int_t stop_loop = 0;
  Int_t big_loop = 0;
  Int_t small_loop =0;

  e->abort=0;
  small_interval /=2;

  //
  // These are irradiated modules:
  // currents will be high, so allow up to 100 LV trips each
  //

  for(n=0;n<e->GetMaxModules();n++){
    if(e->m[n]->present){
      e->m[n]->DCS->maxLVtrips =100;
    }
  }

  gROOT->ProcessLine(".L PostRadTest.cpp");

  // Main loop

  while(e->abort==0){


    // Monitor currents for up to "big_loop_end" seconds

    st_start_stopper();
    small_loop = 0;
    big_loop_end = big_interval + timer->GetRealTime();

    while((timer->GetRealTime()<big_loop_end)&&(stop_loop==0)){

      printf("Time since start: %ld seconds\n",timer->GetRealTime()-start_time);
      printf("Loop %d_%d: Entering trigger phase\n",big_loop,small_loop);
      e->DCSAction();
      e->ExecuteConfigs();

      e->RunFree(); // start triggers

      // wait small interval

      small_loop_end = small_interval + timer->GetRealTime();
      while(timer->GetRealTime()<small_loop_end){
        // DO NOWT!!
      }

      e->DCSAction();

      printf("Filling tree...\n");
      for(n=0;n<e->GetMaxModules();n++){
        if(e->m[n]->present){
          DCSTree->SetBranchAddress("DCSBranch",&e->m[n]->DCS);
          DCSTree->Fill();
        }
      }

      DCSTree->Write();

      printf("Loop %d_%d: Entering idle phase\n",big_loop,small_loop);
      e->RunStop(); // start triggers

      // wait small interval

      small_loop_end = small_interval + timer->GetRealTime();
      while(timer->GetRealTime()<small_loop_end){
        // DO NOWT!!
      }

      stop_loop=st_do_stop();
      small_loop++;
    }
    st_stop_stopper();

    if(e->abort==0){
      printf("Time since start: %ld seconds\n",timer->GetRealTime()-start_time);
      printf("Loop %d: Entering Measurement phase\n",big_loop);

      //
      // Make Measurements Here....
      //

      PostRadTest();

    }

    stop_loop=st_do_stop();
    big_loop++;

  } // end of main loop

  // Save file and Power Off

  e->LVOff();
  outfile->Close();
}


void LTPostRadTest(){
  //
  // default is to make DCS measurements every 5 minutes
  // with module tests every 12 hours
  //

  LTPostRadTest(300,43200);
}

