//
// ModuleLTT.cpp   Macro for Long Term Tests of Modules
//
// Version 0.1  PWP  12/10/01
//

#ifdef DATA_DIRECTORY
  // do not reload parameters.h
#else
  // must load parameters.h
#include <parameters.h>
#endif

#include "TLTT.h"

void ModuleLTT(Int_t small, Int_t big, Int_t total) {

  // Creates and does a Hybrid Long Term Test

  gROOT->ProcessLine(".L TLTT.cpp") ;
  TLTT *t = new TLTT(small,big,total) ;
  t->ModuleLTT() ;
  delete t;
}

void ModuleLTT() {
  // Current/temperature monitored every 5 min
  // Confirmation Test every 2 hours
  // Characterisation Test at the end
  // Standard duration of test 24 hours
  
  ModuleLTT(300,7200,24*3600) ;
}
