void No(Int_t go_slow, Int_t do_qthr) { 

  //
  // version 0.1  PWP 08.12.00
  // version 0.11 PWP 23.01.01
  // version 0.2  PWP 09.05.01
  //

  Char_t mname[32];
  Float_t qstart=-1.5,qstop=1.5,qstep, test;

  // load the analysis macro 
  gROOT->ProcessLine(".L NOQscan.cpp");
  gROOT->ProcessLine(".L NoPlot.cpp");

  //Store settings before the scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;

  e->do_cal_loop=0;       // cal loop OFF
  e->do_fits=1;           // integrated fitting ON
  e->do_vary_ntrigs=1;    // increase number of triggers at low occupancy

  e->burst_trtype=0;      // single L1A
  e->burst_ntrigs=2000;
  e->burst_maxtrigs=1000000;

  //
  // Don't ask me why, but this is a workaround for the
  // "misplaced hits" problem.  I have absolutely no idea
  // why taking this burst should change anything...
  // PWP 20.04.01
  //

  if(go_slow==1){
    e->ConfigureVariable(1,0);
    e->ExecuteConfigs();
    st_menu_decoded_burst();
  }

  // end workaround

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF

  if(do_qthr){
    gROOT->ProcessLine(".L mV2fC.cpp");
    for(Int_t i=0; i<e->num_showmods;i++){
      if(e->m[i]->present){
	e->GetModuleName(i,mname);
	test = mV2fC(mname,5.);
	if(test>qstart) qstart = test;
      }
    }
    qstep = mV2fC(mname,0,102.5)-mV2fC(mname,0,100.);
    e->ConfigureScan(41,qstart,qstop,qstep);  // 1 - Threshold (fC)
  }
  else
    e->ConfigureScan(1,0,150,2.5);  // 1 - Threshold (mV)
  //e->ConfigureScan(1,0,120,2.5);  // 1 - Threshold (mV)


  // If the option "go_slow" is selected, or if the user does not 
  // have CLOAC, Decoded Burst will be used instead of DecodedVBurst.
  // Under these circumstances DAQ will proceed as "trigger - readout"
  // rather than in bursts of triggers at 100kHz frequency.

  if((e->nCLOAC==0)||(go_slow==2)){
    st_scan(100,-1);      // DecodedBurst

  } else {
    e->cc->periodic_sr=0;
    e->cc->periodic_bcr=0;
    e->cc->randomiser=0;
    e->cc->SetPeriodicFreq((double)100.0); // trigger frequency in kHz

    if(go_slow==0){        // VBurst
      st_scan(12,-1);
    }else if(go_slow==1){
      st_scan(102,-1);      // DecodedVBurst
    }
  }

  // Reset values after scan
  e->RestoreState();

  //
  // Call the analysis macro.
  // Arguments are:
  //  run, scan, log_scale, graphics, postscript
  //

  if(e->abort) return;

  if(do_qthr)
    NOQscan(e->runnum, e->scannum);
  else
    NoPlot(e->runnum, e->scannum,1,0,1);
} 

void No(){
  No(0,0);
}

