void NobuGain(Short_t dowait, Short_t postscript){

  // Compatible with Nobu's method (??)
  // version 0.1 PWP 04.10.00
  // version 0.2 PWP 10.12.00

  Int_t n_points = 3;
  Int_t special_point = 1;
  Int_t scans[3];
  Float_t charges[3] = {0.00,2.00,3.00};

  Short_t fit_type = 4;   // linear fit

  // load the plot macro 
  gROOT->ProcessLine(".L ResponseCurvePlot.cpp");

  e->StOutScanReset();
  e->ascii_nt=0;
  e->abort=0;

  e->do_fits = 1;        // integrated fitting must be turned on

  //e->burst_trtype = 0;   // Nobu does not do this, but we
                           // should really select L1A triggers
                           // (no cal pulse) if we wish to
                           // measure the noise occupancy offset

  if(e->abort==0){
    e->ConfigureVariable(42,charges[0]);  // 42 - QCAL in fC
    e->ConfigureScan(1,0,200,2.5);
    st_scan(11,-1);
    scans[0]=e->scannum;
  }

  e->burst_trtype = 3;   // back to calibration triggers

  if(e->abort==0){
    e->ConfigureVariable(42,charges[1]);
    e->ConfigureScan(1,50,250,5);
    st_scan(11,-1);
    scans[1]=e->scannum;
  }

  if(e->abort==0){
    e->ConfigureVariable(42,charges[2]);
    e->ConfigureScan(1,50,300,5);
    st_scan(11,-1);
    scans[2]=e->scannum;
  }

  if(e->abort==0){
    ResponseCurvePlot(e->runnum,n_points,special_point,scans,charges,fit_type,dowait,postscript,0);
  }
}

void NobuGain(){

  // if called with no arguments, do not wait between pages of output
  // but still generate the postscript file

  NobuGain(0,1);
}

