void Scan2Text(int run, int scan, int module){

  // Routine to convert ROOT scan histogram to tab seperated text file
  //
  // Version 0.10 PWP 06.02.02
  // Version 0.11 PWP 28.02.02 Trival bugfix. Less haste, more speed!
  // Version 0.12 BJG 30.04.02 Fix some memory leaks

  Char_t  f_name[128], h_name[64];
  Int_t   x,y;

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include "../macros/parameters.h"
  #endif

  //
  // Open file
  //
  
  sprintf(f_name,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan);
  TFile *strun = new TFile(f_name);

  sprintf(h_name,"h_scan0;%d",module+1);
  TH2F *h_scan0= (TH2F*)strun->Get(h_name);

  sprintf(h_name,"h_scan1;%d",module+1);
  TH2F *h_scan1= (TH2F*)strun->Get(h_name);

  sprintf(f_name,"%sstrun%d_%d_%d.txt",DATA_DIRECTORY,run,scan,module);
  FILE* outfile = fopen(f_name,"w");
  if(outfile==NULL){
    printf("Could not open output file\n");
  } else {

    for(x=0;x<h_scan0->GetNbinsX();x++){
      fprintf(outfile,"%d\t",x);
      for(y=1;y<h_scan0->GetNbinsY()+1;y++){
        fprintf(outfile,"%1.2e\t",h_scan0->GetCellContent(x,y));
      }
      fprintf(outfile,"\n");
    }

    for(x=0;x<h_scan1->GetNbinsX();x++){
      fprintf(outfile,"%d\t",x+768);
      for(y=1;y<h_scan1->GetNbinsY()+1;y++){
        fprintf(outfile,"%1.2e\t",h_scan1->GetCellContent(x,y));
      }
      fprintf(outfile,"\n");
    }

    fclose(outfile);
  }

  if(strun) {
    strun->Close();
    delete strun;
  }
}



