void StreamDelay(Int_t do_restart) { 

  //
  // version 0.1 PWP 31.07.00
  //

  // load the analysis macro 
  gROOT->ProcessLine(".L StreamDelayPlot.cpp");

  //Store settings before the scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;

  e->do_cal_loop=0;       // cal loop OFF
  e->do_fits=0;           // integrated fitting OFF

  e->burst_trtype=35;     // single soft reset, pulse input 
                          // register and L1A using SLOG 
  e->burst_ntrigs=100;

  e->debug_level=1;       // suppress almost all output to screen

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(7,3);   // No masked channels
  e->ConfigureVariable(14,0);  // Route Mask to Pipeline      


  e->ConfigureScan(20,0,25,1);  // 20 - stream delay

  st_scan(11,-1);


  // Reset values after scan
  e->RestoreState();

  // NB. During production testing, the "Restart" should be
  // skipped to save time, it takes much longer than the scan
  // itself!!  The mask and trim files need only be loaded
  // prior to the analogue tests PWP 23.11.00

  if(do_restart){
    e->Restart();              // Reload mask and trim files.
  }

  //
  // Call the analysis macro.
  // Arguments are:
  //  run, scan, module
  //

  StreamDelayPlot(e->runnum, e->scannum,-1,1,0,0);
} 

void StreamDelay(){

  // By default, mask and trim files are reloaded
  // after the scan. PWP 31.07.00

  StreamDelay(1);
}

