Bool_t DCSSafety(Bool_t start){

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  Bool_t alive;
  Float_t response;

  // action only for the system tests
  Char_t line[256];
  sprintf(line,"%s",LOCATION_NAME);
  if(strcmp("B186 Barrel System Test",line) &&
     strcmp("B186 Forward System Test",line)) return kFALSE;

  printf("\nQuerying DCS.....");
  //      if(response=e->DCSSafety(1)){
  if(start)
    response = e->DCSMessg("LVstat 1");
  else
    response = e->DCSMessg("LVstat 0");
  alive = (response != -999.);

  if(alive){
    response = e->DCSMessg("LVoff?");
    alive = (response != -999.);
  }

  if(!alive || response==1.){
    if(response==1.)
      printf(" DCS detected problem -> ERROR!\n");
    else
      printf(" no response from DCS -> ERROR!\n");
    printf("LV+HV will be shut down and data taking will be aborted\n");
    e->LVOff();
    e->HVRamp(1);
    if(response==1) response = e->DCSMessg("LVstat 0");
    return kTRUE;
  }
  else
    printf("OK\n");
  return kFALSE;
}
