//////////////////////////////////////////////////////////
//   This class has been automatically generated 
//     (Tue Feb 19 14:17:19 2002 by ROOT version3.02/07)
//   from TTree EvTree/tree with hit/event
//   found on file: D:\sctvar\data\strun851_1.root
//////////////////////////////////////////////////////////


#ifndef Evtree_h
#define Evtree_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>

class Evtree {
   public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain
//Declaration of leaves types
   Char_t          strm0[768];
   Char_t          strm1[768];
   Int_t           hits0[7];
   Int_t           hits1[7];

//List of branches
   TBranch        *b_strm0;   //!
   TBranch        *b_strm1;   //!
   TBranch        *b_hits0;   //!
   TBranch        *b_hits1;   //!

   Evtree(TTree *tree=0);
   ~Evtree();
   Int_t  Cut(Int_t entry);
   Int_t  GetEntry(Int_t entry);
   Int_t  LoadTree(Int_t entry);
   void   Init(TTree *tree);
   void   Loop();
   Bool_t Notify();
   void   Show(Int_t entry = -1);
};

#endif

Evtree::Evtree(TTree *tree)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("Memory Directory");
      if (!f) {
         f = new TFile("Memory Directory");
         f->cd("Rint:/");
      }
      tree = (TTree*)gDirectory->Get("EvTree");

   }
   Init(tree);
}

Evtree::~Evtree()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t Evtree::GetEntry(Int_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Int_t Evtree::LoadTree(Int_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Int_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->IsA() != TChain::Class()) return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void Evtree::Init(TTree *tree)
{
//   Set branch addresses
   if (tree == 0) return;
   fChain    = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("strm0",strm0);
   fChain->SetBranchAddress("strm1",strm1);
   fChain->SetBranchAddress("hits0",hits0);
   fChain->SetBranchAddress("hits1",hits1);
   Notify();
}

Bool_t Evtree::Notify()
{
   // Called when loading a new file.
   // Get branch pointers.
   b_strm0 = fChain->GetBranch("strm0");
   b_strm1 = fChain->GetBranch("strm1");
   b_hits0 = fChain->GetBranch("hits0");
   b_hits1 = fChain->GetBranch("hits1");
   return kTRUE;
}

void Evtree::Show(Int_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t Evtree::Cut(Int_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
