void ExtTriggerBurst(Int_t tottrg, Float_t thr_chg){
  
  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  #define TRG_BST   25000

  int n;
  int n_bursts = (Int_t) tottrg/TRG_BST;

  gROOT->ProcessLine(".L systest/AccumBursts.cpp");

  //Store settings before the scan
  e->SaveState();

  // Configure the scan

  e->StOutScanReset();
  e->ascii_nt=0;

  e->do_cal_loop=0;       // cal loop OFF
  e->do_fits=0;           // integrated fitting OFF
  e->do_vary_ntrigs=0;    // don't increase number of triggers

  e->burst_type = 20;
  e->burst_ntrigs = TRG_BST;
  e->burst_trtype = 0;  
  e->ConfigureVariable(27,115);  // Trigger Delay
  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,0);  // Route Mask OFF
  e->ConfigureVariable(41,thr_chg); // set Qthr

  e->ExecuteConfigs();

  // Accumulated Bursts  
  // reset abort flag
  e->abort = 0;
  // start stop/abort panel
  st_start_stopper();

  st_do_stop();
  if(e->abort==0) 
    AccumBursts(n_bursts);
  else
    break;
  st_stop_stopper();


  e->RestoreState();

}

    
//  for (n=0; n<e->num_showmods; n++){
//  if(e->m[n]->present) e->m[n]->PrintBurst();
//  }

