void GetCMN(Int_t chip, Int_t Nevt, Double_t Qthr, Double_t Ne_obs, Double_t var_obs, Double_t *CMN, Double_t *ENC_plot){
  
  Double_t real_sigma_random, real_sigma_z, real_sigma_tot, sigma_z;
  Double_t threshold, paras[2];
  Double_t accuracy, var_calc, n=128.0, Ne;
  
  Double_t corr = 1.0;

  //an ugly double search that matches Ne and Var...

  Double_t diff = var_obs - (Ne_obs * (1- (Ne_obs/128)));

  if(diff > 0.0){

    Double_t ENC1 = 1000;
    Double_t ENC2 = 1500;
    Double_t ENC3 = 2000;

    do{

      real_sigma_tot = ENC1;
    
      Double_t var1, ratio1 = 0.001;
      Double_t var2, ratio2 = 0.1;
      Double_t var3, ratio3 = 0.9;
      
      // first guess at ENC
      
      do{
	
	//first guess
	
	real_sigma_z = real_sigma_tot * ratio1;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var1 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//second guess
	
	real_sigma_z = real_sigma_tot * ratio2;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var2 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//third guess
	
	real_sigma_z = real_sigma_tot * ratio3;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var3 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//find interval in which obs_var lies
		
	accuracy = TMath::Sqrt((var2 - var_obs)*(var2-var_obs));

     	
	if(var_obs>var1 && var_obs<var2){
	  ratio1=ratio1;
	  ratio3=ratio2;
	  ratio2=(ratio2+ratio1)/2.0;
	}
	if(var_obs>var2 && var_obs<var3){
	  ratio1=ratio2;
	  ratio3=ratio3;
	  ratio2=(ratio3+ratio2)/2.0;
	}
	if(var_obs<var1 || var_obs>var3){
	  //	  printf("%lf  %lf %lf %lf %lf %lf var outside bounds 1\n", var_obs,var1,var3, ratio1, ratio2,ratio3);
	  accuracy = 0.0000001;
	}
	
      }while (accuracy > 0.000001 );
    
      Double_t Ne1 = Ne;

      //second guess at ENC
      
      real_sigma_tot = ENC2;
      
      Double_t var1, ratio1 = 0.0001;
      Double_t var2, ratio2 = 0.1;
      Double_t var3, ratio3 = 0.9;
            
      do{
	
	//first guess
	
	real_sigma_z = real_sigma_tot * ratio1;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var1 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//second guess
	
	real_sigma_z = real_sigma_tot * ratio2;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var2 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//third guess
	
	real_sigma_z = real_sigma_tot * ratio3;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var3 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
	
	//find interval in which obs_var lies
		
	accuracy = TMath::Sqrt((var2 - var_obs)*(var2-var_obs));
	
	if(var_obs>var1 && var_obs<var2){
	  ratio1=ratio1;
	  ratio3=ratio2;
	  ratio2=(ratio2+ratio1)/2.0;
	}
	if(var_obs>var2 && var_obs<var3){
	  ratio1=ratio2;
	  ratio3=ratio3;
	  ratio2=(ratio3+ratio2)/2.0;
	}
	if(var_obs<var1 || var_obs>var3){
	  //	  printf("%lf %lf  %lf %lf %lf %lf %lf var outside bounds 2\n", var_obs,var1,var3, ratio1, ratio2,ratio3,ENC2);
	  accuracy = 0.0000001;
	}
	
      }while (accuracy > 0.000001 );
    
      Double_t Ne2 = Ne;
      
      //third guess at ENC
      
      real_sigma_tot = ENC3;
      
      Double_t var1, ratio1 = 0.001;
      Double_t var2, ratio2 = 0.1;
      Double_t var3, ratio3 = 0.9;
            
      do{
	
	//first guess
	
	real_sigma_z = real_sigma_tot * ratio1;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var1 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//second guess
	
	real_sigma_z = real_sigma_tot * ratio2;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr / real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var2 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//third guess
	
	real_sigma_z = real_sigma_tot * ratio3;
	real_sigma_random = TMath::Sqrt((real_sigma_tot*real_sigma_tot) - (real_sigma_z * real_sigma_z));
	sigma_z = real_sigma_z/real_sigma_random;
	threshold = 6242 * Qthr * corr/ real_sigma_random;
	
	Ne = n/2 * TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(sigma_z*sigma_z)))));
	
	var3 = Ne*(1-Ne) + (n * (n-1) * TMath::Sqrt(1+(2*sigma_z*sigma_z))/4 * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))) * (TMath::Erfc(threshold/(TMath::Sqrt(2*(1+(2*sigma_z*sigma_z)))))));
	
	var_calc = Ne * (1- (Ne/128));
		
	//find interval in which obs_var lies
		
	accuracy = TMath::Sqrt((var2 - var_obs)*(var2-var_obs));

	//printf("%lf %lf %lf %lf\n", var1, var2, var3, var_obs);


	if(var_obs>var1 && var_obs<var2){
	  ratio1=ratio1;
	  ratio3=ratio2;
	  ratio2=(ratio2+ratio1)/2.0;
	}
	if(var_obs>var2 && var_obs<var3){
	  ratio1=ratio2;
	  ratio3=ratio3;
	  ratio2=(ratio3+ratio2)/2.0;
	}
	if(var_obs<var1 || var_obs>var3){
	  //	  printf("%lf  %lf %lf %lf %lf %lf var outside bounds 3\n", var_obs,var1,var3, ratio1, ratio2,ratio3);
	  accuracy = 0.0000001;
	}
	
      }while (accuracy > 0.000001 );
    
      Double_t Ne3 = Ne;
      
      Double_t Neaccuracy = TMath::Sqrt((Ne2 - Ne_obs)*(Ne2-Ne_obs));
	
      if( Ne_obs> Ne1 && Ne_obs< Ne2){
	ENC1=ENC1;
	ENC3=ENC2;
	ENC2=(ENC2+ENC1)/2.0;
      }
      if(Ne_obs> Ne2 && Ne_obs< Ne3){
	ENC1=ENC2;
	ENC3=ENC3;
	ENC2=(ENC3+ENC2)/2.0;
      }
      if( Ne_obs< Ne1 ||  Ne_obs> Ne3){
	printf("%lf %lf %lf %lf  ENC outside bounds\n", Ne_obs, Ne1, Ne2,Ne3);
	Neaccuracy = 0.0000001;
      }

    }while (Neaccuracy > 0.000001 );

    *CMN = ratio2 * real_sigma_tot;

    printf("%lf %lf %lf %lf %lf %lf\n", *CMN, Ne_obs, Ne2, var_obs, var2, ENC2);
  
    *ENC_plot = ENC2;
  
  }else{
    
    *CMN = 0.0;
    *ENC_plot = 0.0;
    printf("%lf\n", *CMN);
    
  }

}

#include <parameters.h>

void GammaPlot(Int_t run, Int_t scan){

  Char_t fname[128],text[256],mname[MAX_MODULES][50];
  FILE *in, *out;
  Int_t nread=1,i,nmod=0,nevt,chip;
  Double_t ENC,Ne,Var,dummy,Qthr;
  Double_t ENC_plot[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t rENC_plot[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t CMN[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t duCMN[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t ddCMN[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t index[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t xup[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t xdn[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Double_t chip_plot[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  TGraphAsymmErrors* gr;

  sprintf(fname,"%sGammas_preana_%d_%d.txt",RESULTS_DIRECTORY,run,scan);
  in = fopen(fname,"r");
  if(!in){
    printf("Can't open file %s\n",fname);
    return;
  }

  sprintf(fname,"%sGammas_%d_%d.txt",RESULTS_DIRECTORY,run,scan);
  out = fopen(fname,"w");
  if(!out){
    printf("Can't open file %s\n",fname);
    return;
  }

  nread = fscanf(in,"%s",text);
  if(nread!=1) return;
  nread = fscanf(in,"%s",text);
  if(nread!=1) return;
  nread = fscanf(in,"%d",&nevt);
  if(nread!=1) return;
  nread = fscanf(in,"%s",text);
  if(nread!=1) return;
  nread = fscanf(in,"%s",text);
  if(nread!=1) return;
  nread = fscanf(in,"%s",text);
  if(nread!=1) return;
  for(i=0;i<4;i++)
    fname[i]=text[5+i];
  fname[4]='\0';
  sscanf(fname,"%lf",&Qthr);
  for(i=0;i<5;i++){
    nread = fscanf(in,"%s",text);
    if(nread!=1) break;
  }

  while(nread && nmod < MAX_MODULES){

    nread = fscanf(in,"%s\t%d",mname[nmod],&chip);
    if(nread!=2) break;
    nread = fscanf(in,"%lf\t%le\t%le",&ENC,&Ne,&Var);
    if(nread!=3) break;

    Double_t Ne_err = (TMath::Sqrt(Var))/(TMath::Sqrt(nevt));
    Double_t Var_err = (2 * Var) / (TMath::Sqrt (2.0* nevt));

    Double_t Var_dn = Var - Var_err;
    Double_t Var_up = Var + Var_err;

    Double_t Ne_dn  = Ne - Ne_err;
    Double_t Ne_up  = Ne + Ne_err;
 
    Int_t pp = nmod*MAX_CHIPS*MAX_LINKS+chip;

    rENC_plot[nmod*MAX_CHIPS*MAX_LINKS+chip] = ENC;
    chip_plot[nmod*MAX_CHIPS*MAX_LINKS+chip] = nmod*MAX_CHIPS*MAX_LINKS+chip;

    
    GetCMN(pp, nevt,Qthr,Ne,Var,&(CMN[nmod*MAX_CHIPS*MAX_LINKS+chip]),&(ENC_plot[nmod*MAX_CHIPS*MAX_LINKS+chip]));   

    GetCMN(pp, nevt,Qthr,Ne_up,Var_dn,&(ddCMN[nmod*MAX_CHIPS*MAX_LINKS+chip]),&(ENC_plot[nmod*MAX_CHIPS*MAX_LINKS+chip])); 
    GetCMN(pp, nevt,Qthr,Ne_dn,Var_up,&(duCMN[nmod*MAX_CHIPS*MAX_LINKS+chip]),&(ENC_plot[nmod*MAX_CHIPS*MAX_LINKS+chip]));   
    
    ddCMN[nmod*MAX_CHIPS*MAX_LINKS+chip] = 
    CMN[nmod*MAX_CHIPS*MAX_LINKS+chip]   -  ddCMN[nmod*MAX_CHIPS*MAX_LINKS+chip];
    duCMN[nmod*MAX_CHIPS*MAX_LINKS+chip] = 
    duCMN[nmod*MAX_CHIPS*MAX_LINKS+chip] -  CMN[nmod*MAX_CHIPS*MAX_LINKS+chip];

    index[nmod*MAX_CHIPS*MAX_LINKS+chip] = 0.5+(Double_t) nmod*MAX_CHIPS*MAX_LINKS+chip;
    xup[nmod*MAX_CHIPS*MAX_LINKS+chip] = 0.;
    xdn[nmod*MAX_CHIPS*MAX_LINKS+chip] = 0.;
    fprintf(out,"%s\t%d\t%lf\t%lf\t%lf\t\n",
	    mname[nmod],
	    chip,
	    CMN[nmod*MAX_CHIPS*MAX_LINKS+chip],
	    ddCMN[nmod*MAX_CHIPS*MAX_LINKS+chip],
	    duCMN[nmod*MAX_CHIPS*MAX_LINKS+chip]);
    if(chip==11) nmod++;
  }

  fclose(in);
  fclose(out);

  TCanvas* can;
  can = new TCanvas("cmn","cmn",700,400);
  can->cd();
  can->Clear();

  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
  pad_text->Draw();
  pad_plot->Draw();
  can->Update();
  pad_text->cd();
  TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
  t1->SetFillColor(10);
  t1->SetTextAlign(13);
  t1->SetTextSize(0.3);
  t1->SetTextColor(4);
  sprintf(text,"ATLAS SCT: Common mode noise from double-iteration method");
  //if(time)  sprintf(text,"%s  -  %s",text,time->GetName());
  //if(place) sprintf(text,"%s  -  %s",text,place->GetName());
  t1->AddText(text);
  sprintf(text,"Run %d   Scan %d", run,scan);
  t1->AddText(text);
  sprintf(text,"%d events ar Q_{thr}=%.2lffC",nevt,Qthr);
  t1->AddText(text);
  t1->Draw();
  can->Update();
    
  pad_plot->cd();
  pad_plot->Range(-15,-200,nmod*12+10,600);
  TGaxis *xax = new TGaxis(0,0,nmod*12,0,0,nmod,6*100+nmod,"U");
  xax->SetName("xaxis");
  xax->SetTitle("Module");
  xax->Draw();
  TGaxis *yax = new TGaxis(0,0,0,500,0,500,808,"");
  yax->SetName("yaxis");
  yax->SetTitle("Common mode noise (ENC)");
  yax->Draw();
  for(i=0;i<=nmod;i++){
    l = new TLine(i*12,0,i*12,500);
    l->Draw();
  }
  for(i=0;i<nmod;i++){
    TText t;
    t.SetTextSize(0.04);
    t.DrawText((Double_t)(i*12+1),-100.,mname[i]);
  }
  l = new TLine(0,500,nmod*12,500);
  l->Draw();

  gr = new TGraphAsymmErrors(nmod*MAX_CHIPS*MAX_LINKS,index,CMN,xup,xdn,ddCMN,duCMN);
  gr->SetMarkerStyle(20);
  gr->SetMarkerSize(.5);
  gr->SetMarkerColor((Color_t) 2);
  gr->SetLineColor((Color_t) 2);
  gr->Draw("P");

  can->Update();


  TGraph* grep;
  grep = new TGraph(nmod*MAX_CHIPS*MAX_LINKS,chip_plot,ENC_plot);
  TGraph* grer;
  grer = new TGraph(nmod*MAX_CHIPS*MAX_LINKS,chip_plot,rENC_plot);
  grer->SetMarkerStyle(20);
  grer->SetMarkerSize(.5);
  grer->SetMarkerColor(3);

  grep->SetMarkerStyle(20);
  grep->SetMarkerSize(.5);
  grep->SetMarkerColor(2);

  TCanvas* can2;
  can2 = new TCanvas("enc","enc",700,400);
  can2->cd();
  can2->Clear();
  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
  pad_text->Draw();
  pad_plot->Draw();
  can->Update();
  pad_text->cd();
  TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
  t1->SetFillColor(10);
  t1->SetTextAlign(13);
  t1->SetTextSize(0.3);
  t1->SetTextColor(4);
  sprintf(text,"Comparison of predicted and measured ENCs");
  t1->AddText(text);
  sprintf(text,"Run %d   Scan %d", run,scan);
  t1->AddText(text);
  sprintf(text,"%d events ar Q_{thr}=%.2lffC",nevt,Qthr);
  t1->AddText(text);
  t1->Draw();
  can->Update();
    
  pad_plot->cd();
  grep->SetMaximum(1500);
  grep->SetMinimum(1000);

  grep->Draw("AP");
  grer->Draw("P");
    

  return;
}


