void idetmon(Int_t index){

  Int_t i;
  Double_t tstart=0.,tnow;
  Char_t s[128],fname[128];

  gROOT->ProcessLine(".L systest/sleep.cpp");

  sprintf(fname,"J:\\barrelsct\\irrad_test\\dcslog_%d.root",index);
  TFile * out = new TFile(fname,"RECREATE");

  TStopwatch clock;

  // reset abort flag
  e->abort = 0;
  // start stop/abort panel
  st_start_stopper();

  for(i=0;i<30;i++){
    
    st_do_stop();
    if(e->abort!=0) break;

    e->HVRamp(0); // to keep SCTHV busy before querying
    sleep(2);

    if(i==0) tstart = clock.GetRealTime();
    tnow = (clock.GetRealTime()-tstart)/60.;
    printf("Readings at %.2lf\n",tnow);
    sprintf(s,"%.2lf",tnow);
    TObjString *tis = new TObjString(s);
    tis->Write("clk");

    e->m[0]->DCS->Query();
    printf("%.2f\t%.0f\t%.2f\t%.0f\t%.1f\t%.2f\t%.2f\t%.2f\n",
	   e->m[0]->DCS->vcc,e->m[0]->DCS->icc,
	   e->m[0]->DCS->vdd,e->m[0]->DCS->idd,
	   e->m[0]->DCS->vdet,e->m[0]->DCS->idet,
	   e->m[0]->DCS->T1,e->m[0]->DCS->T2);

    sprintf(s,"%f",e->m[0]->DCS->vcc);
    TObjString *vccs = new TObjString(s);
    vccs->Write("Vcc");
    sprintf(s,"%f",e->m[0]->DCS->vdd);
    TObjString *vdds = new TObjString(s);
    vdds->Write("Vdd");
    sprintf(s,"%f",e->m[0]->DCS->icc);
    TObjString *iccs = new TObjString(s);
    iccs->Write("Icc");
    sprintf(s,"%f",e->m[0]->DCS->idd);
    TObjString *idds = new TObjString(s);
    idds->Write("Idd");
    sprintf(s,"%f",e->m[0]->DCS->vdet);
    TObjString *vdets = new TObjString(s);
    vdets->Write("Vdet");
    sprintf(s,"%f",e->m[0]->DCS->idet);
    TObjString *idets = new TObjString(s);
    idets->Write("Idet");
    sprintf(s,"%f",e->m[0]->DCS->T1);
    TObjString *t1s = new TObjString(s);
    t1s->Write("T1");
    sprintf(s,"%f",e->m[0]->DCS->T2);
    TObjString *t2s = new TObjString(s);
    t2s->Write("T2");
    sprintf(s,"%3.1f",e->DCSMessg("temperature 0"));
    TObjString * et1s = new TObjString(s);
    et1s->Write("ET1");
    sprintf(s,"%3.1f",e->DCSMessg("temperature 1"));
    TObjString * et2s = new TObjString(s);
    et2s->Write("ET2");

    sleep(120.);
  }

  out->Close();
  
  // remove stop/abort panel
  st_stop_stopper();

  return;
}
