/* optif_lib.h
 * Include file required by users of optif_lib.c.
 * Version 1.1. J.C.Hill. 16 August 2000.
 *
 * V1.0 28 July 2000. JCH. Initial version.
 * V1.1 16 August 2000. JCH. Add routines to return laser and threshold
 * settings.
 */

/* Function prototypes */

int optif_exit();

#if defined (__STDC__)

int optif_bpm_read_channelmask(int identifier, short stream, short *mask);
int optif_bpm_read_coarsedelay(int identifier, short stream, short *delay);
int optif_bpm_read_finedelay(int identifier, short stream, short *delay);
int optif_bpm_read_mkspneg(int identifier, short stream, short *mksp);
int optif_bpm_read_mksppos(int identifier, short stream, short *mksp);
int optif_bpm_read_mode(int identifier, short stream, short *mode);
int optif_bpm_read_pulsewidth(int identifier, short stream, short *width);
int optif_bpm_read_random(int identifier, short stream, short *random);
int optif_bpm_read_testdata(int identifier, short stream, short *value);
int optif_bpm_set_channelmask(int identifier, short stream, short mask);
int optif_bpm_set_coarsedelay(int identifier, short stream, short delay);
int optif_bpm_set_finedelay(int identifier, short stream, short delay);
int optif_bpm_set_mkspneg(int identifier, short stream, short mksp);
int optif_bpm_set_mksppos(int identifier, short stream, short mksp);
int optif_bpm_set_mode(int identifier, short stream, short mode);
int optif_bpm_set_pulsewidth(int identifier, short stream, short width);
int optif_bpm_set_random(int identifier, short stream, short random);
int optif_bpm_set_testdata(int identifier, short stream, short value);
int optif_bpm_syncreset(int identifier, short stream);
int optif_init(int identifier);
int optif_read_clock_invert(int identifier, short *value);
int optif_read_command_invert(int identifier, short *value);
int optif_read_info(int identifier, short *firmware, short *manufacturer, 
					short *version, short *type);
int optif_read_laser(int identifier, short stream, short *value);
int optif_read_receiver_invert(int identifier, short stream, short *value);
int optif_read_threshold(int identifier, short stream, short *value);
int optif_reset_bpm(int identifier, short chip);
int optif_set_clock_invert(int identifier, short value);
int optif_set_command_invert(int identifier, short value);
int optif_set_laser(int identifier, short stream, short value);
int optif_set_receiver_invert(int identifier, short stream, short value);
int optif_set_threshold(int identifier, short stream, short value);
int optif_status(int identifier);
int optif_vmemap(unsigned long address,int *identifier);

#else /* !__STDC__ */

int optif_bpm_read_channelmask();
int optif_bpm_read_coarsedelay();
int optif_bpm_read_finedelay();
int optif_bpm_read_mkspneg();
int optif_bpm_read_mksppos();
int optif_bpm_read_mode();
int optif_bpm_read_pulsewidth();
int optif_bpm_read_random();
int optif_bpm_read_testdata();
int optif_bpm_set_channelmask();
int optif_bpm_set_coarsedelay();
int optif_bpm_set_finedelay();
int optif_bpm_set_mkspneg();
int optif_bpm_set_mksppos();
int optif_bpm_set_mode();
int optif_bpm_set_pulsewidth();
int optif_bpm_set_random();
int optif_bpm_set_testdata();
int optif_bpm_syncreset();
int optif_init();
int optif_read_clock_invert();
int optif_read_command_invert();
int optif_read_info();
int optif_read_laser();
int optif_read_receiver_invert();
int optif_read_threshold();
int optif_reset_bpm();
int optif_set_clock_invert();
int optif_set_command_invert();
int optif_set_laser();
int optif_set_receiver_invert();
int optif_set_threshold();
int optif_status();
int optif_vmemap();

#endif /* __STDC__ */



