#include <TSocket.h>
#include <string.h>
#include "dcs_message.h"

float dcs_message(char* host, int port, char* request){

  // Communication with the LabVIEW DCS system via LabVIEW
  //
  // host: pcppeatlas06.cern.ch
  // port: 186
  //
  // example requests
  //    "TEMPERATURE 0"
  //    "HUMIDITY 1"
  //
  // possible future extensions:
  //    "MODULE 0 T1"
  //    "MODULE 2 SET VDET 100"
  //
  // PWP 08.11.00


  char response[256];
  int length_out = strlen(request);
  int length_in;

  float val;

  // Open the socket
  TSocket* the_socket = new TSocket(host,port);

  if(the_socket->IsValid()){

    // Send the request
    byte_swap(&length_out,4,4);
    the_socket->SendRaw(&length_out,4,kDefault);
    the_socket->SendRaw(request,strlen(request),kDefault);

    // Read length of response
    the_socket->RecvRaw(&length_in,4,kDefault);
    byte_swap(&length_in,4,4);
    if(length_in>256)length_in=256;

    // Read the response
    the_socket->RecvRaw(&response,length_in,kDefault);

    the_socket->Close();

    response[length_in]=0;
    sscanf(response,"%f",&val);
    return val;

  } else {
    return -999.;
  }

}


float dcs_message(char* request){

 return dcs_message("pcppeatlas06.cern.ch",186,request);
//  return dcs_message("ppdnt1.te.rl.ac.uk",5799,request);
}

void byte_swap (void* buf, int bytes, int bytes_to_type){

   // Within a word/nibble/whatever, the bytes are received
   // in the wrong order.   We must unscramble them according 
   // to representation.

   // char  - 1 byte
   // short - 2 bytes
   // int, float - 4 bytes
   // double - 8 bytes

   char  temp[8];
   char* cbuf = (char*) buf;

   int i=0;
   int j=0;

   // must be a neater way to do this??

   while (i<bytes){

     for(j=0;j<bytes_to_type;j++){
       temp[j] = cbuf[j];
     } 

     for(j=0;j<bytes_to_type;j++){
       cbuf[j] = temp[bytes_to_type-j-1];
     }

     cbuf+= bytes_to_type;
     i+= bytes_to_type;
   }
}

