/*
   st.c   Simple test routine for stlib

   GFM 990724
*/

/* #define VXINT */

#ifdef RAID
#include <posix/time.h>
#endif

#include <stdio.h>

#include "../CLOAC/cloac_lib.h"
#include "../SLOG/slog_lib.h"
#include "../MUSTARD/mus_lib.h"
#include "../SCTLV/sctlv_lib.h"
#include "../BILED/biled_lib.h"

#include "../stlib/abc.h"
#include "../stlib/abc_config.h"
#include "../stlib/sct.h"
#include "../stlib/sct_hardware.h"
#include "../stlib/sct_scans.h"
#include "../stlib/st.h"
#include "../stlib/st_config.h"
#include "../stlib/stlib.h"
#include "../stlib/stout.h"

void st_menu();


extern sysmap sct[SCT_MAX_MODULES];

short dump_level = 1;


/* RD13 run parameters: integer only */

int runnum;             /* N.B. run_number is local to module stout.c */
int trigger_delay;      /* Global Cloac trigger delay */
int scanpoint_type;     /* Global scan type */
int scanpoint_value;    /* Global value of scan type for current run */
int scanpoint_index;    /* Index to exceptions file $SCT_PATH/scans/scan.[scan_index] */

float scanpoint_setting;   /* Value interpreted from scanpoint_value */

/* Easy use of ASCII ntuples requires that all these be globals :-( 
 * Maybe use a structure?
 */

extern int scan_number;
extern int burst_number;

short burst_type =1;
short loop_cals=0;
int tmax = 1000;    /* PWP 12.10.99 */
short ttype=3;
short cfgfreq=0;
short srfreq=0;
short bcfreq=0;
short scan_dim=1;

short num_points1=0;
float scan_start1=0;
float scan_step1 =0;
float scan_stop1 =0;

short num_points2=0;
float scan_start2=0;
float scan_step2 =0;
float scan_stop2 =0;

/* RD13 Mustard event type header information */

/* add array[SCT_MAX_MODULES] for header info */


main(){

  printf("SCTRUN: Enter run parameters (ints)\n");
  
  printf("  Run number: "); 
  scanf("%d", &runnum); 
  printf(" ... setting %d\n", runnum);

  printf("  Trigger delay: "); 
  scanf("%d", &trigger_delay);
  printf(" ... setting %d\n", trigger_delay);

/*  printf("  Scanpoint type: "); 
    scanf("%d", &scanpoint_type);
    printf(" ... setting %d\n", scanpoint_type);

    printf("  Scanpoint value: "); 
    scanf("%d", &scanpoint_value);
    printf(" ... setting %d\n", scanpoint_value);

    printf("  Scanpoint exception file index: "); 
    scanf("%d", &scanpoint_index);
    printf(" ... setting %d\n", scanpoint_index); */


  st_startup();

  cc_load_delay((unsigned short)trigger_delay);

/*  st_coerce_variable((short)scanpoint_type, (float)scanpoint_value, &scanpoint_setting);

    st_configure_variable(-1,(short)scanpoint_type,scanpoint_setting);

    st_scanpoint_file(scanpoint_index); */
  
  st_execute_configs(dump_level);
  st_execute_configs(dump_level);

  st_menu();

  return 0;
}


  
void st_menu() {
  char cm[128];
  char c;
  int v = 0;
  int run = 1;
  short scan_type, tr_type, var_type;
  float scan_start,scan_stop,scan_step,var_setting;

  while(run) {
    printf("SCTRUN: Power: 0(off) 1(on) h(HardReset) x(ExecuteConfigs) q(Quit)\n");
    printf("        Cloac: r(Run) s(Stop) t(Single) c(SingleCal) g(SoftReset) \n");
    printf("        Slog:\n");
    printf("        Sys:   w(ShowSysmap) W(ChangeSysmap) d(ShowModules)\n");  
    printf("        Run:   b(TBurst) v(ChangeVariable) n(ReloadScanpoint)\n");
    printf("        Scan:  N(1D scaN) k(changevariable by Key input\n");
    scanf("%1s", cm);
    c = cm[0];

    if      (c == 'q') { st_power_off(); run = 0; }
    else if (c == '0') { st_power_off(); }
    else if (c == '1') { st_power_on(); }
    else if (c == 'h') { st_hard_reset(); }
    else if (c == 'x') { st_execute_configs(dump_level); }

    else if (c == 'r') { st_run(1,20); }   /* start free running triggers (type,frequency) */
    else if (c == 's') { st_stop(); }      /* stop free running triggers */
    else if (c == 't') { st_single(0); }   /* single L1A */
    else if (c == 'c') { st_single(3); }   /* single cal_strobe + delay + L1A */
    else if (c == 'g') { st_single(1); }   /* single soft reset */

    else if (c == 'w') { st_show_sysmap(); }
    else if (c == 'W') { st_menu_sysmap(); }
    else if (c == 'd') { st_show_module(0); }

    else if (c == 'C') { /* Cloac menu */; }
    else if (c == 'S') { /* Slog menu */; }
    else if (c == 'M') { /* Mustard menu */; }
    else if (c == 'V') { /* SCTLV menu */; }
   
    else if (c == 'b') { 
      st_tburst(1000,3,0,0,0,24);  
    }
    else if (c == 'v') { st_scanpoint_file(scanpoint_index); }
    else if (c == 'N') {
      printf("some scan types: 1  - ST_VTHR\n");
      printf("                 2  - ST_VCAL,\n"); 
      printf("                 3  - ST_STROBE_DELAY\n");
      printf("                 20 - ST_STREAM_DELAY\n\n");
      printf("some trigger types: 0  - L1\n");
      printf("                    3  - cal_strobe + L1\n");
      printf("                    20 - pulse_input_reg + L1\n\n");

      printf("scan_type:    "); scanf("%hd",&scan_type);
      printf("trigger_type: "); scanf("%hd",&tr_type);
      printf("scan_start:   "); scanf("%f",&scan_start);
      printf("scan_stop:    "); scanf("%f",&scan_stop);
      printf("scan_step:    "); scanf("%f",&scan_step);
      printf("Scan var %d trigger type %d from %3.2f to %3.2f in %3.2f steps\n",
              scan_type, tr_type, scan_start, scan_stop, scan_step);

      printf("\nContinue? (y/n)"); scanf("%1s", cm);
      c = cm[0];
      if (c == 'y'){
        ttype = tr_type;
        st_scan(scan_type,scan_start,scan_stop,scan_step);
      }
    }
    else if (c == 'k') {
      printf("some var types: 1  - ST_VTHR\n");
      printf("                2  - ST_VCAL,\n"); 
      printf("                3  - ST_STROBE_DELAY\n");
      printf("                4  - ST_PREAMP\n");
      printf("                5  - ST_SHAPER\n");
      printf("                20 - ST_STREAM_DELAY\n\n");

      printf("var_type:    "); scanf("%hd",&var_type);
      printf("var_setting: "); scanf("%f",&var_setting);
      st_coerce_variable(var_type,var_setting, &var_setting);

      printf("\nContinue? (y/n)"); scanf("%1s", cm);
      c = cm[0];
      if (c == 'y'){
        st_configure_variable(-1,var_type,var_setting);
        st_execute_configs(dump_level);
      }
    }
    else {
        printf("SCTRUN: ERROR: unknown command %c\n", c);
    }
  }
}

void st_scan(short scan_type, float req_scan_start, float req_scan_stop, float req_scan_step){
  /* Perform simple 1 dimensional scan with ASCII ntuple output */

  float scanpoint_setting;
  int scanpoint; 
  float calpoint;
  int cal_max_points;
  int n_trigs = 1000;

  /* coersion assumes all values are POSITIVE; scan_start and scan_stop 
   * should be positive in any case.  Here we impose no limit to the 
   * number of scanpoints since we do not compile the 2d histogram */

  printf("Scan var %d trigger type %d from %3.2f to %3.2f in %3.2f steps\n",
    scan_type, ttype, req_scan_start, req_scan_stop, req_scan_step);

  if(req_scan_step<0) req_scan_step = req_scan_step * (float)-1.0;

  st_coerce_variable(scan_type, req_scan_start, &scan_start1); 
  st_coerce_variable(scan_type, req_scan_stop, &scan_stop1); 
  st_coerce_variable(scan_type, req_scan_step, &scan_step1); 

  if(scan_start1>scan_stop1) scan_step1 = scan_step1 *(float)-1.0;
  num_points1 = (int)(((scan_stop1-scan_start1)+(scan_step1*3/2))/scan_step1); 

  printf("Scan var %d from %3.2f to %3.2f in %3.2f steps - %d steps total\n",
    scan_type, scan_start1, scan_stop1, scan_step1, num_points1);

  /* loop over cal lines only if trigger type == cal + L1 */
  if ((ttype == 3)&&((scan_type==ST_VTHR)||(scan_type==ST_VCAL))){
    cal_max_points = 4;
    loop_cals = 1;
  }else{
    cal_max_points = 1;
    loop_cals = 0;
  }

  stout_open((short)runnum);
  if(scan_number==0) stout_sor();
  st_scan_increment();

  for(scanpoint=0; scanpoint<=num_points1; scanpoint++){
 
    st_coerce_variable(scan_type, scan_start1+(scanpoint*scan_step1), &scanpoint_setting);
    st_configure_variable(-1, scan_type, scanpoint_setting);

    for(calpoint=0; calpoint<cal_max_points; calpoint++){

      st_configure_variable(-1, 10, calpoint);
      st_execute_configs(dump_level);
      st_tburst(tmax,ttype,cfgfreq,srfreq,bcfreq,24);
    }
  }
  stout_close();
}

