abcd2t_timewalk(Float_t one_fc, Float_t edge_mode) { 

  //  Performs a set of Strobe delay scans to determine the timewalk 
  //  Scans are to be fitted with stan_fitscan.cpp, this is presently
  //  done last just in case ROOT should crash!!
  //  Argument one_fc is given to set the threshold to 1 fC. 
 
  if(edge_mode){
    printf("Timewalk scan for EDGE MODE\n");
    e->ConfigureVariable(13,1);   // Edge Detect ON 
    e->ConfigureVariable(11,2);   // Edge Compression
    e->ConfigureVariable(27,129); // trig_delay to 130 to centre pulse 
  }else{
    printf("Timewalk scan for LEVEL MODE\n");
    e->ConfigureVariable(13,0);   // Edge Detect OFF 
    e->ConfigureVariable(11,1);   // Level Mode Compression
    e->ConfigureVariable(27,129); // trig_delay to 130 to centre pulse 
  }

  e->StOutScanReset(); 
  e->ascii_nt=0;                  // Set 1 if you want to use the ascii ntuple
                                 // - but 0 will save a _lot_ of disk space!! 

  e->ConfigureVariable(1,one_fc); // Set VTHR to 1fC 
 
  e->ConfigureScan(3,0,63,1);     // Scan Strobe Delay in units of 1 bin 
  
  e->ConfigureVariable(42,1.10);  // Variable type 42 - QCAL (fC) 
  st_scan(1,-1);

  Int_t start_scan = e->scannum;

  e->ConfigureVariable(42,1.25); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,1.50); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,1.75); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,2.00); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,3.00); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,4.00); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,5.00); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,6.00); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,8.00); 
  st_scan(1,-1); 

  e->ConfigureVariable(42,10.00); 
  st_scan(1,-1);

  // Move one BCO to calibrate the delay scale 
  e->ConfigureVariable(27,128); 

  e->ConfigureVariable(42,10.00); 
  st_scan(1,-1);

  // Load fit macros

  gROOT->ProcessLine(".L stan_fitscan.cpp");
  gROOT->ProcessLine(".L stan_fittw.cpp");

  // fit scan data

  for(i=start_scan;i<start_scan+12;i++){ 
    stan_fitscan(e->runnum,i,0,0,1,0);
    stan_fitscan(e->runnum,i,0,1,1,0);
  }

  stan_fittw(e->runnum,start_scan,0,0,1,2,0,1);

} 

abcd2t_timewalk(Float_t one_fc) { 

  abcd2t_timewalk(one_fc,1);
}

