abcd2t_trimscan(Float_t cal, short nmods){

  // Macro to take nfC threshold scan for each and
  // every trimdac setting - resulting fit data 
  // can be analysed by stan_trims.cpp
  // N.B. argument cal is in mV: 10mV ~1fC for ABCD
  // P. W. Phillips, 06.10.99
  // revised PWP 11.03.00
  // revised PWP 04.08.00 - multi module version

  Float_t trim;
  int i,scan;

  e->StOutScanReset();
  e->ascii_nt=0;

  if(cal<0.5){
    e->burst_trtype=0;             // select L1A only
    e->burst_ntrigs=10000;         // 10000 events/burst
    e->ConfigureVariable(2,0);
    e->ConfigureVariable(6,0);     // set trimdac
    e->ConfigureScan(1,0,200,2.5); // set threshold scan

  }else{
    e->ConfigureVariable(2,cal);   // set charge
    e->ConfigureVariable(6,0);     // set trimdac
    e->ConfigureScan(1,0,400,5);   // set threshold scan
  }

  for(trim=0;trim<16;trim++){
    e->ConfigureVariable(6,trim);  // set trimdac
    st_scan(1,-1);                 // do scan
  }


  gROOT->ProcessLine(".L stan_fitscan.cpp");
  for(scan=(e->scannum)-15;scan<=(e->scannum);scan++){
    for(i=0;i<nmods;i++){
      stan_fitscan(e->runnum,scan,i,0);
      stan_fitscan(e->runnum,scan,i,1);
    }
  }
}

abcd2t_trimscan(Float_t cal){

  abcd2t_trimscan(cal,1);
}

abcd2t_trimscan(){

  abcd2t_trimscan(20,1);
}

